<?php

/**
 * Common intl. standards (ISO etc.) related data & methods
 *
 * @package Redaxo
 **/
class rex_standards
{

  /**
   * Return array of PHP timezones
   *
   * @see http://pecl.php.net/get/timezonedb
   * @return array  timezones
   **/
  public static function getTimezones()
  {
    return array(
      'Africa/Abidjan'                  ,
      'Africa/Accra'                    ,
      'Africa/Addis_Ababa'              ,
      'Africa/Algiers'                  ,
      'Africa/Asmara'                   ,
      'Africa/Asmera'                   ,
      'Africa/Bamako'                   ,
      'Africa/Bangui'                   ,
      'Africa/Banjul'                   ,
      'Africa/Bissau'                   ,
      'Africa/Blantyre'                 ,
      'Africa/Brazzaville'              ,
      'Africa/Bujumbura'                ,
      'Africa/Cairo'                    ,
      'Africa/Casablanca'               ,
      'Africa/Ceuta'                    ,
      'Africa/Conakry'                  ,
      'Africa/Dakar'                    ,
      'Africa/Dar_es_Salaam'            ,
      'Africa/Djibouti'                 ,
      'Africa/Douala'                   ,
      'Africa/El_Aaiun'                 ,
      'Africa/Freetown'                 ,
      'Africa/Gaborone'                 ,
      'Africa/Harare'                   ,
      'Africa/Johannesburg'             ,
      'Africa/Juba'                     ,
      'Africa/Kampala'                  ,
      'Africa/Khartoum'                 ,
      'Africa/Kigali'                   ,
      'Africa/Kinshasa'                 ,
      'Africa/Lagos'                    ,
      'Africa/Libreville'               ,
      'Africa/Lome'                     ,
      'Africa/Luanda'                   ,
      'Africa/Lubumbashi'               ,
      'Africa/Lusaka'                   ,
      'Africa/Malabo'                   ,
      'Africa/Maputo'                   ,
      'Africa/Maseru'                   ,
      'Africa/Mbabane'                  ,
      'Africa/Mogadishu'                ,
      'Africa/Monrovia'                 ,
      'Africa/Nairobi'                  ,
      'Africa/Ndjamena'                 ,
      'Africa/Niamey'                   ,
      'Africa/Nouakchott'               ,
      'Africa/Ouagadougou'              ,
      'Africa/Porto-Novo'               ,
      'Africa/Sao_Tome'                 ,
      'Africa/Timbuktu'                 ,
      'Africa/Tripoli'                  ,
      'Africa/Tunis'                    ,
      'Africa/Windhoek'                 ,
      'America/Adak'                    ,
      'America/Anchorage'               ,
      'America/Anguilla'                ,
      'America/Antigua'                 ,
      'America/Araguaina'               ,
      'America/Argentina/Buenos_Aires'  ,
      'America/Argentina/Catamarca'     ,
      'America/Argentina/ComodRivadavia',
      'America/Argentina/Cordoba'       ,
      'America/Argentina/Jujuy'         ,
      'America/Argentina/La_Rioja'      ,
      'America/Argentina/Mendoza'       ,
      'America/Argentina/Rio_Gallegos'  ,
      'America/Argentina/Salta'         ,
      'America/Argentina/San_Juan'      ,
      'America/Argentina/San_Luis'      ,
      'America/Argentina/Tucuman'       ,
      'America/Argentina/Ushuaia'       ,
      'America/Aruba'                   ,
      'America/Asuncion'                ,
      'America/Atikokan'                ,
      'America/Atka'                    ,
      'America/Bahia'                   ,
      'America/Bahia_Banderas'          ,
      'America/Barbados'                ,
      'America/Belem'                   ,
      'America/Belize'                  ,
      'America/Blanc-Sablon'            ,
      'America/Boa_Vista'               ,
      'America/Bogota'                  ,
      'America/Boise'                   ,
      'America/Buenos_Aires'            ,
      'America/Cambridge_Bay'           ,
      'America/Campo_Grande'            ,
      'America/Cancun'                  ,
      'America/Caracas'                 ,
      'America/Catamarca'               ,
      'America/Cayenne'                 ,
      'America/Cayman'                  ,
      'America/Chicago'                 ,
      'America/Chihuahua'               ,
      'America/Coral_Harbour'           ,
      'America/Cordoba'                 ,
      'America/Costa_Rica'              ,
      'America/Creston'                 ,
      'America/Cuiaba'                  ,
      'America/Curacao'                 ,
      'America/Danmarkshavn'            ,
      'America/Dawson'                  ,
      'America/Dawson_Creek'            ,
      'America/Denver'                  ,
      'America/Detroit'                 ,
      'America/Dominica'                ,
      'America/Edmonton'                ,
      'America/Eirunepe'                ,
      'America/El_Salvador'             ,
      'America/Ensenada'                ,
      'America/Fort_Wayne'              ,
      'America/Fortaleza'               ,
      'America/Glace_Bay'               ,
      'America/Godthab'                 ,
      'America/Goose_Bay'               ,
      'America/Grand_Turk'              ,
      'America/Grenada'                 ,
      'America/Guadeloupe'              ,
      'America/Guatemala'               ,
      'America/Guayaquil'               ,
      'America/Guyana'                  ,
      'America/Halifax'                 ,
      'America/Havana'                  ,
      'America/Hermosillo'              ,
      'America/Indiana/Indianapolis'    ,
      'America/Indiana/Knox'            ,
      'America/Indiana/Marengo'         ,
      'America/Indiana/Petersburg'      ,
      'America/Indiana/Tell_City'       ,
      'America/Indiana/Vevay'           ,
      'America/Indiana/Vincennes'       ,
      'America/Indiana/Winamac'         ,
      'America/Indianapolis'            ,
      'America/Inuvik'                  ,
      'America/Iqaluit'                 ,
      'America/Jamaica'                 ,
      'America/Jujuy'                   ,
      'America/Juneau'                  ,
      'America/Kentucky/Louisville'     ,
      'America/Kentucky/Monticello'     ,
      'America/Knox_IN'                 ,
      'America/Kralendijk'              ,
      'America/La_Paz'                  ,
      'America/Lima'                    ,
      'America/Los_Angeles'             ,
      'America/Louisville'              ,
      'America/Lower_Princes'           ,
      'America/Maceio'                  ,
      'America/Managua'                 ,
      'America/Manaus'                  ,
      'America/Marigot'                 ,
      'America/Martinique'              ,
      'America/Matamoros'               ,
      'America/Mazatlan'                ,
      'America/Mendoza'                 ,
      'America/Menominee'               ,
      'America/Merida'                  ,
      'America/Metlakatla'              ,
      'America/Mexico_City'             ,
      'America/Miquelon'                ,
      'America/Moncton'                 ,
      'America/Monterrey'               ,
      'America/Montevideo'              ,
      'America/Montreal'                ,
      'America/Montserrat'              ,
      'America/Nassau'                  ,
      'America/New_York'                ,
      'America/Nipigon'                 ,
      'America/Nome'                    ,
      'America/Noronha'                 ,
      'America/North_Dakota/Beulah'     ,
      'America/North_Dakota/Center'     ,
      'America/North_Dakota/New_Salem'  ,
      'America/Ojinaga'                 ,
      'America/Panama'                  ,
      'America/Pangnirtung'             ,
      'America/Paramaribo'              ,
      'America/Phoenix'                 ,
      'America/Port-au-Prince'          ,
      'America/Port_of_Spain'           ,
      'America/Porto_Acre'              ,
      'America/Porto_Velho'             ,
      'America/Puerto_Rico'             ,
      'America/Rainy_River'             ,
      'America/Rankin_Inlet'            ,
      'America/Recife'                  ,
      'America/Regina'                  ,
      'America/Resolute'                ,
      'America/Rio_Branco'              ,
      'America/Rosario'                 ,
      'America/Santa_Isabel'            ,
      'America/Santarem'                ,
      'America/Santiago'                ,
      'America/Santo_Domingo'           ,
      'America/Sao_Paulo'               ,
      'America/Scoresbysund'            ,
      'America/Shiprock'                ,
      'America/Sitka'                   ,
      'America/St_Barthelemy'           ,
      'America/St_Johns'                ,
      'America/St_Kitts'                ,
      'America/St_Lucia'                ,
      'America/St_Thomas'               ,
      'America/St_Vincent'              ,
      'America/Swift_Current'           ,
      'America/Tegucigalpa'             ,
      'America/Thule'                   ,
      'America/Thunder_Bay'             ,
      'America/Tijuana'                 ,
      'America/Toronto'                 ,
      'America/Tortola'                 ,
      'America/Vancouver'               ,
      'America/Virgin'                  ,
      'America/Whitehorse'              ,
      'America/Winnipeg'                ,
      'America/Yakutat'                 ,
      'America/Yellowknife'             ,
      'Antarctica/Casey'                ,
      'Antarctica/Davis'                ,
      'Antarctica/DumontDUrville'       ,
      'Antarctica/Macquarie'            ,
      'Antarctica/Mawson'               ,
      'Antarctica/McMurdo'              ,
      'Antarctica/Palmer'               ,
      'Antarctica/Rothera'              ,
      'Antarctica/South_Pole'           ,
      'Antarctica/Syowa'                ,
      'Antarctica/Vostok'               ,
      'Arctic/Longyearbyen'             ,
      'Asia/Aden'                       ,
      'Asia/Almaty'                     ,
      'Asia/Amman'                      ,
      'Asia/Anadyr'                     ,
      'Asia/Aqtau'                      ,
      'Asia/Aqtobe'                     ,
      'Asia/Ashgabat'                   ,
      'Asia/Ashkhabad'                  ,
      'Asia/Baghdad'                    ,
      'Asia/Bahrain'                    ,
      'Asia/Baku'                       ,
      'Asia/Bangkok'                    ,
      'Asia/Beirut'                     ,
      'Asia/Bishkek'                    ,
      'Asia/Brunei'                     ,
      'Asia/Calcutta'                   ,
      'Asia/Choibalsan'                 ,
      'Asia/Chongqing'                  ,
      'Asia/Chungking'                  ,
      'Asia/Colombo'                    ,
      'Asia/Dacca'                      ,
      'Asia/Damascus'                   ,
      'Asia/Dhaka'                      ,
      'Asia/Dili'                       ,
      'Asia/Dubai'                      ,
      'Asia/Dushanbe'                   ,
      'Asia/Gaza'                       ,
      'Asia/Harbin'                     ,
      'Asia/Hebron'                     ,
      'Asia/Ho_Chi_Minh'                ,
      'Asia/Hong_Kong'                  ,
      'Asia/Hovd'                       ,
      'Asia/Irkutsk'                    ,
      'Asia/Istanbul'                   ,
      'Asia/Jakarta'                    ,
      'Asia/Jayapura'                   ,
      'Asia/Jerusalem'                  ,
      'Asia/Kabul'                      ,
      'Asia/Kamchatka'                  ,
      'Asia/Karachi'                    ,
      'Asia/Kashgar'                    ,
      'Asia/Kathmandu'                  ,
      'Asia/Katmandu'                   ,
      'Asia/Kolkata'                    ,
      'Asia/Krasnoyarsk'                ,
      'Asia/Kuala_Lumpur'               ,
      'Asia/Kuching'                    ,
      'Asia/Kuwait'                     ,
      'Asia/Macao'                      ,
      'Asia/Macau'                      ,
      'Asia/Magadan'                    ,
      'Asia/Makassar'                   ,
      'Asia/Manila'                     ,
      'Asia/Muscat'                     ,
      'Asia/Nicosia'                    ,
      'Asia/Novokuznetsk'               ,
      'Asia/Novosibirsk'                ,
      'Asia/Omsk'                       ,
      'Asia/Oral'                       ,
      'Asia/Phnom_Penh'                 ,
      'Asia/Pontianak'                  ,
      'Asia/Pyongyang'                  ,
      'Asia/Qatar'                      ,
      'Asia/Qyzylorda'                  ,
      'Asia/Rangoon'                    ,
      'Asia/Riyadh'                     ,
      'Asia/Saigon'                     ,
      'Asia/Sakhalin'                   ,
      'Asia/Samarkand'                  ,
      'Asia/Seoul'                      ,
      'Asia/Shanghai'                   ,
      'Asia/Singapore'                  ,
      'Asia/Taipei'                     ,
      'Asia/Tashkent'                   ,
      'Asia/Tbilisi'                    ,
      'Asia/Tehran'                     ,
      'Asia/Tel_Aviv'                   ,
      'Asia/Thimbu'                     ,
      'Asia/Thimphu'                    ,
      'Asia/Tokyo'                      ,
      'Asia/Ujung_Pandang'              ,
      'Asia/Ulaanbaatar'                ,
      'Asia/Ulan_Bator'                 ,
      'Asia/Urumqi'                     ,
      'Asia/Vientiane'                  ,
      'Asia/Vladivostok'                ,
      'Asia/Yakutsk'                    ,
      'Asia/Yekaterinburg'              ,
      'Asia/Yerevan'                    ,
      'Atlantic/Azores'                 ,
      'Atlantic/Bermuda'                ,
      'Atlantic/Canary'                 ,
      'Atlantic/Cape_Verde'             ,
      'Atlantic/Faeroe'                 ,
      'Atlantic/Faroe'                  ,
      'Atlantic/Jan_Mayen'              ,
      'Atlantic/Madeira'                ,
      'Atlantic/Reykjavik'              ,
      'Atlantic/South_Georgia'          ,
      'Atlantic/St_Helena'              ,
      'Atlantic/Stanley'                ,
      'Australia/ACT'                   ,
      'Australia/Adelaide'              ,
      'Australia/Brisbane'              ,
      'Australia/Broken_Hill'           ,
      'Australia/Canberra'              ,
      'Australia/Currie'                ,
      'Australia/Darwin'                ,
      'Australia/Eucla'                 ,
      'Australia/Hobart'                ,
      'Australia/LHI'                   ,
      'Australia/Lindeman'              ,
      'Australia/Lord_Howe'             ,
      'Australia/Melbourne'             ,
      'Australia/North'                 ,
      'Australia/NSW'                   ,
      'Australia/Perth'                 ,
      'Australia/Queensland'            ,
      'Australia/South'                 ,
      'Australia/Sydney'                ,
      'Australia/Tasmania'              ,
      'Australia/Victoria'              ,
      'Australia/West'                  ,
      'Australia/Yancowinna'            ,
      'Brazil/Acre'                     ,
      'Brazil/DeNoronha'                ,
      'Brazil/East'                     ,
      'Brazil/West'                     ,
      'Canada/Atlantic'                 ,
      'Canada/Central'                  ,
      'Canada/East-Saskatchewan'        ,
      'Canada/Eastern'                  ,
      'Canada/Mountain'                 ,
      'Canada/Newfoundland'             ,
      'Canada/Pacific'                  ,
      'Canada/Saskatchewan'             ,
      'Canada/Yukon'                    ,
      'CET'                             ,
      'Chile/Continental'               ,
      'Chile/EasterIsland'              ,
      'CST6CDT'                         ,
      'Cuba'                            ,
      'EET'                             ,
      'Egypt'                           ,
      'Eire'                            ,
      'EST'                             ,
      'EST5EDT'                         ,
      'Etc/GMT'                         ,
      'Etc/GMT+0'                       ,
      'Etc/GMT+1'                       ,
      'Etc/GMT+10'                      ,
      'Etc/GMT+11'                      ,
      'Etc/GMT+12'                      ,
      'Etc/GMT+2'                       ,
      'Etc/GMT+3'                       ,
      'Etc/GMT+4'                       ,
      'Etc/GMT+5'                       ,
      'Etc/GMT+6'                       ,
      'Etc/GMT+7'                       ,
      'Etc/GMT+8'                       ,
      'Etc/GMT+9'                       ,
      'Etc/GMT-0'                       ,
      'Etc/GMT-1'                       ,
      'Etc/GMT-10'                      ,
      'Etc/GMT-11'                      ,
      'Etc/GMT-12'                      ,
      'Etc/GMT-13'                      ,
      'Etc/GMT-14'                      ,
      'Etc/GMT-2'                       ,
      'Etc/GMT-3'                       ,
      'Etc/GMT-4'                       ,
      'Etc/GMT-5'                       ,
      'Etc/GMT-6'                       ,
      'Etc/GMT-7'                       ,
      'Etc/GMT-8'                       ,
      'Etc/GMT-9'                       ,
      'Etc/GMT0'                        ,
      'Etc/Greenwich'                   ,
      'Etc/UCT'                         ,
      'Etc/Universal'                   ,
      'Etc/UTC'                         ,
      'Etc/Zulu'                        ,
      'Europe/Amsterdam'                ,
      'Europe/Andorra'                  ,
      'Europe/Athens'                   ,
      'Europe/Belfast'                  ,
      'Europe/Belgrade'                 ,
      'Europe/Berlin'                   ,
      'Europe/Bratislava'               ,
      'Europe/Brussels'                 ,
      'Europe/Bucharest'                ,
      'Europe/Budapest'                 ,
      'Europe/Chisinau'                 ,
      'Europe/Copenhagen'               ,
      'Europe/Dublin'                   ,
      'Europe/Gibraltar'                ,
      'Europe/Guernsey'                 ,
      'Europe/Helsinki'                 ,
      'Europe/Isle_of_Man'              ,
      'Europe/Istanbul'                 ,
      'Europe/Jersey'                   ,
      'Europe/Kaliningrad'              ,
      'Europe/Kiev'                     ,
      'Europe/Lisbon'                   ,
      'Europe/Ljubljana'                ,
      'Europe/London'                   ,
      'Europe/Luxembourg'               ,
      'Europe/Madrid'                   ,
      'Europe/Malta'                    ,
      'Europe/Mariehamn'                ,
      'Europe/Minsk'                    ,
      'Europe/Monaco'                   ,
      'Europe/Moscow'                   ,
      'Europe/Nicosia'                  ,
      'Europe/Oslo'                     ,
      'Europe/Paris'                    ,
      'Europe/Podgorica'                ,
      'Europe/Prague'                   ,
      'Europe/Riga'                     ,
      'Europe/Rome'                     ,
      'Europe/Samara'                   ,
      'Europe/San_Marino'               ,
      'Europe/Sarajevo'                 ,
      'Europe/Simferopol'               ,
      'Europe/Skopje'                   ,
      'Europe/Sofia'                    ,
      'Europe/Stockholm'                ,
      'Europe/Tallinn'                  ,
      'Europe/Tirane'                   ,
      'Europe/Tiraspol'                 ,
      'Europe/Uzhgorod'                 ,
      'Europe/Vaduz'                    ,
      'Europe/Vatican'                  ,
      'Europe/Vienna'                   ,
      'Europe/Vilnius'                  ,
      'Europe/Volgograd'                ,
      'Europe/Warsaw'                   ,
      'Europe/Zagreb'                   ,
      'Europe/Zaporozhye'               ,
      'Europe/Zurich'                   ,
      'Factory'                         ,
      'GB'                              ,
      'GB-Eire'                         ,
      'GMT'                             ,
      'GMT+0'                           ,
      'GMT-0'                           ,
      'GMT0'                            ,
      'Greenwich'                       ,
      'Hongkong'                        ,
      'HST'                             ,
      'Iceland'                         ,
      'Indian/Antananarivo'             ,
      'Indian/Chagos'                   ,
      'Indian/Christmas'                ,
      'Indian/Cocos'                    ,
      'Indian/Comoro'                   ,
      'Indian/Kerguelen'                ,
      'Indian/Mahe'                     ,
      'Indian/Maldives'                 ,
      'Indian/Mauritius'                ,
      'Indian/Mayotte'                  ,
      'Indian/Reunion'                  ,
      'Iran'                            ,
      'Israel'                          ,
      'Jamaica'                         ,
      'Japan'                           ,
      'Kwajalein'                       ,
      'Libya'                           ,
      'MET'                             ,
      'Mexico/BajaNorte'                ,
      'Mexico/BajaSur'                  ,
      'Mexico/General'                  ,
      'MST'                             ,
      'MST7MDT'                         ,
      'Navajo'                          ,
      'NZ'                              ,
      'NZ-CHAT'                         ,
      'Pacific/Apia'                    ,
      'Pacific/Auckland'                ,
      'Pacific/Chatham'                 ,
      'Pacific/Chuuk'                   ,
      'Pacific/Easter'                  ,
      'Pacific/Efate'                   ,
      'Pacific/Enderbury'               ,
      'Pacific/Fakaofo'                 ,
      'Pacific/Fiji'                    ,
      'Pacific/Funafuti'                ,
      'Pacific/Galapagos'               ,
      'Pacific/Gambier'                 ,
      'Pacific/Guadalcanal'             ,
      'Pacific/Guam'                    ,
      'Pacific/Honolulu'                ,
      'Pacific/Johnston'                ,
      'Pacific/Kiritimati'              ,
      'Pacific/Kosrae'                  ,
      'Pacific/Kwajalein'               ,
      'Pacific/Majuro'                  ,
      'Pacific/Marquesas'               ,
      'Pacific/Midway'                  ,
      'Pacific/Nauru'                   ,
      'Pacific/Niue'                    ,
      'Pacific/Norfolk'                 ,
      'Pacific/Noumea'                  ,
      'Pacific/Pago_Pago'               ,
      'Pacific/Palau'                   ,
      'Pacific/Pitcairn'                ,
      'Pacific/Pohnpei'                 ,
      'Pacific/Ponape'                  ,
      'Pacific/Port_Moresby'            ,
      'Pacific/Rarotonga'               ,
      'Pacific/Saipan'                  ,
      'Pacific/Samoa'                   ,
      'Pacific/Tahiti'                  ,
      'Pacific/Tarawa'                  ,
      'Pacific/Tongatapu'               ,
      'Pacific/Truk'                    ,
      'Pacific/Wake'                    ,
      'Pacific/Wallis'                  ,
      'Pacific/Yap'                     ,
      'Poland'                          ,
      'Portugal'                        ,
      'PRC'                             ,
      'PST8PDT'                         ,
      'ROC'                             ,
      'ROK'                             ,
      'Singapore'                       ,
      'Turkey'                          ,
      'UCT'                             ,
      'Universal'                       ,
      'US/Alaska'                       ,
      'US/Aleutian'                     ,
      'US/Arizona'                      ,
      'US/Central'                      ,
      'US/East-Indiana'                 ,
      'US/Eastern'                      ,
      'US/Hawaii'                       ,
      'US/Indiana-Starke'               ,
      'US/Michigan'                     ,
      'US/Mountain'                     ,
      'US/Pacific'                      ,
      'US/Pacific-New'                  ,
      'US/Samoa'                        ,
      'UTC'                             ,
      'W-SU'                            ,
      'WET'                             ,
      'Zulu'                            ,
    );
  } // END getTimezones



  /**
   * Return array of ISO 3166-* country codes, ccTLDs and translated country names (EN,DE,ES,FR,IT,PT)
   *
   * @see http://www.iso.org/iso/country_codes.htm
   * @return  array  array with ISO codes, ccTLDs, and translated country names (EN,DE,ES,FR,IT,PT)
   **/
  public static function getCountryCodes()
  {
    return array(
                 // --- DYN
    'AD' => array(
      'iso_3166_1_alpha_3' => 'AND',
      'iso_3166_1_numeric' => '20',
      'ccTLD'              => '.ad',
      'name_EN'            => 'Andorra',
      'name_DE'            => 'Andorra',
      'name_ES'            => 'Andorra',
      'name_FR'            => 'Andorre',
      'name_IT'            => 'Andorra',
      'name_PT'            => 'Andorra'
      ),
    'AE' => array(
      'iso_3166_1_alpha_3' => 'ARE',
      'iso_3166_1_numeric' => '784',
      'ccTLD'              => '.ae',
      'name_EN'            => 'United Arab Emirates',
      'name_DE'            => 'Vereinigte Arabische Emirate',
      'name_ES'            => 'Emiratos Árabes Unidos',
      'name_FR'            => 'Émirats arabes unis',
      'name_IT'            => 'Emirati Arabi Uniti',
      'name_PT'            => 'Emiratos Árabes Unidos'
      ),
    'AF' => array(
      'iso_3166_1_alpha_3' => 'AFG',
      'iso_3166_1_numeric' => '4',
      'ccTLD'              => '.af',
      'name_EN'            => 'Afghanistan',
      'name_DE'            => 'Afghanistan',
      'name_ES'            => 'Afganistán',
      'name_FR'            => 'Afghanistan',
      'name_IT'            => 'Afghanistan',
      'name_PT'            => 'Afeganistão'
      ),
    'AG' => array(
      'iso_3166_1_alpha_3' => 'ATG',
      'iso_3166_1_numeric' => '28',
      'ccTLD'              => '.ag',
      'name_EN'            => 'Antigua and Barbuda',
      'name_DE'            => 'Antigua und Barbuda',
      'name_ES'            => 'Antigua y Barbuda',
      'name_FR'            => 'Antigua-et-Barbuda',
      'name_IT'            => 'Antigua e Barbuda',
      'name_PT'            => 'Antigua e Barbuda'
      ),
    'AI' => array(
      'iso_3166_1_alpha_3' => 'AIA',
      'iso_3166_1_numeric' => '660',
      'ccTLD'              => '.ai',
      'name_EN'            => 'Anguilla',
      'name_DE'            => 'Anguilla',
      'name_ES'            => 'Anguila',
      'name_FR'            => 'Anguilla',
      'name_IT'            => 'Anguilla',
      'name_PT'            => 'Anguilla'
      ),
    'AL' => array(
      'iso_3166_1_alpha_3' => 'ALB',
      'iso_3166_1_numeric' => '8',
      'ccTLD'              => '.al',
      'name_EN'            => 'Albania',
      'name_DE'            => 'Albanien',
      'name_ES'            => 'Albania',
      'name_FR'            => 'Albanie',
      'name_IT'            => 'Albania',
      'name_PT'            => 'Albânia'
      ),
    'AM' => array(
      'iso_3166_1_alpha_3' => 'ARM',
      'iso_3166_1_numeric' => '51',
      'ccTLD'              => '.am',
      'name_EN'            => 'Armenia',
      'name_DE'            => 'Armenien',
      'name_ES'            => 'Armenia',
      'name_FR'            => 'Arménie',
      'name_IT'            => 'Armenia',
      'name_PT'            => 'Arménia'
      ),
    'AN' => array(
      'iso_3166_1_alpha_3' => 'ANT',
      'iso_3166_1_numeric' => '530',
      'ccTLD'              => '.an',
      'name_EN'            => 'Netherlands Antilles',
      'name_DE'            => 'Niederländische Antillen',
      'name_ES'            => 'Antillas Neerlandesas',
      'name_FR'            => 'Antilles néerlandaises',
      'name_IT'            => 'Antille Olandesi',
      'name_PT'            => 'Antilhas Holandesas'
      ),
    'AO' => array(
      'iso_3166_1_alpha_3' => 'AGO',
      'iso_3166_1_numeric' => '24',
      'ccTLD'              => '.ao',
      'name_EN'            => 'Angola',
      'name_DE'            => 'Angola',
      'name_ES'            => 'Angola',
      'name_FR'            => 'Angola',
      'name_IT'            => 'Angola',
      'name_PT'            => 'Angola'
      ),
    'AQ' => array(
      'iso_3166_1_alpha_3' => 'ATA',
      'iso_3166_1_numeric' => '10',
      'ccTLD'              => '.aq',
      'name_EN'            => 'Antarctica',
      'name_DE'            => 'Antarktis',
      'name_ES'            => 'Antártida',
      'name_FR'            => 'Antarctique',
      'name_IT'            => 'Antartide',
      'name_PT'            => 'Antárctida'
      ),
    'AR' => array(
      'iso_3166_1_alpha_3' => 'ARG',
      'iso_3166_1_numeric' => '32',
      'ccTLD'              => '.ar',
      'name_EN'            => 'Argentina',
      'name_DE'            => 'Argentinien',
      'name_ES'            => 'Argentina',
      'name_FR'            => 'Argentine',
      'name_IT'            => 'Argentina',
      'name_PT'            => 'Argentina'
      ),
    'AS' => array(
      'iso_3166_1_alpha_3' => 'ASM',
      'iso_3166_1_numeric' => '16',
      'ccTLD'              => '.as',
      'name_EN'            => 'American Samoa',
      'name_DE'            => 'Amerikanisch-Samoa',
      'name_ES'            => 'Samoa Americana',
      'name_FR'            => 'Samoa américaines',
      'name_IT'            => 'Samoa Americane',
      'name_PT'            => 'Samoa Americana'
      ),
    'AT' => array(
      'iso_3166_1_alpha_3' => 'AUT',
      'iso_3166_1_numeric' => '40',
      'ccTLD'              => '.at',
      'name_EN'            => 'Austria',
      'name_DE'            => 'Österreich',
      'name_ES'            => 'Austria',
      'name_FR'            => 'Autriche',
      'name_IT'            => 'Austria',
      'name_PT'            => 'Áustria'
      ),
    'AU' => array(
      'iso_3166_1_alpha_3' => 'AUS',
      'iso_3166_1_numeric' => '36',
      'ccTLD'              => '.au',
      'name_EN'            => 'Australia',
      'name_DE'            => 'Australien',
      'name_ES'            => 'Australia',
      'name_FR'            => 'Australie',
      'name_IT'            => 'Australia',
      'name_PT'            => 'Austrália'
      ),
    'AW' => array(
      'iso_3166_1_alpha_3' => 'ABW',
      'iso_3166_1_numeric' => '533',
      'ccTLD'              => '.aw',
      'name_EN'            => 'Aruba',
      'name_DE'            => 'Aruba',
      'name_ES'            => 'Aruba',
      'name_FR'            => 'Aruba',
      'name_IT'            => 'Aruba',
      'name_PT'            => 'Aruba'
      ),
    'AX' => array(
      'iso_3166_1_alpha_3' => 'ALA',
      'iso_3166_1_numeric' => '248',
      'ccTLD'              => '.ax',
      'name_EN'            => 'Åland Islands',
      'name_DE'            => 'Åland',
      'name_ES'            => 'Åland',
      'name_FR'            => 'Åland',
      'name_IT'            => 'Åland',
      'name_PT'            => 'Åland'
      ),
    'AZ' => array(
      'iso_3166_1_alpha_3' => 'AZE',
      'iso_3166_1_numeric' => '31',
      'ccTLD'              => '.az',
      'name_EN'            => 'Azerbaijan',
      'name_DE'            => 'Aserbaidschan',
      'name_ES'            => 'Azerbaiyán',
      'name_FR'            => 'Azerbaïdjan',
      'name_IT'            => 'Azerbaijan',
      'name_PT'            => 'Azerbeijão'
      ),
    'BA' => array(
      'iso_3166_1_alpha_3' => 'BIH',
      'iso_3166_1_numeric' => '70',
      'ccTLD'              => '.ba',
      'name_EN'            => 'Bosnia and Herzegovina',
      'name_DE'            => 'Bosnien und Herzegowina',
      'name_ES'            => 'Bosnia y Herzegovina',
      'name_FR'            => 'Bosnie-Herzégovine',
      'name_IT'            => 'Bosnia-Erzegovina',
      'name_PT'            => 'Bósnia-Herzegovina'
      ),
    'BB' => array(
      'iso_3166_1_alpha_3' => 'BRB',
      'iso_3166_1_numeric' => '52',
      'ccTLD'              => '.bb',
      'name_EN'            => 'Barbados',
      'name_DE'            => 'Barbados',
      'name_ES'            => 'Barbados',
      'name_FR'            => 'Barbade',
      'name_IT'            => 'Barbados',
      'name_PT'            => 'Barbados'
      ),
    'BD' => array(
      'iso_3166_1_alpha_3' => 'BGD',
      'iso_3166_1_numeric' => '50',
      'ccTLD'              => '.bd',
      'name_EN'            => 'Bangladesh',
      'name_DE'            => 'Bangladesch',
      'name_ES'            => 'Bangladesh',
      'name_FR'            => 'Bangladesh',
      'name_IT'            => 'Bangladesh',
      'name_PT'            => 'Bangladesh'
      ),
    'BE' => array(
      'iso_3166_1_alpha_3' => 'BEL',
      'iso_3166_1_numeric' => '56',
      'ccTLD'              => '.be',
      'name_EN'            => 'Belgium',
      'name_DE'            => 'Belgien',
      'name_ES'            => 'Bélgica',
      'name_FR'            => 'Belgique',
      'name_IT'            => 'Belgio',
      'name_PT'            => 'Bélgica'
      ),
    'BF' => array(
      'iso_3166_1_alpha_3' => 'BFA',
      'iso_3166_1_numeric' => '854',
      'ccTLD'              => '.bf',
      'name_EN'            => 'Burkina Faso',
      'name_DE'            => 'Burkina Faso',
      'name_ES'            => 'Burkina Faso',
      'name_FR'            => 'Burkina Faso',
      'name_IT'            => 'Burkina Faso',
      'name_PT'            => 'Burkina Faso'
      ),
    'BG' => array(
      'iso_3166_1_alpha_3' => 'BGR',
      'iso_3166_1_numeric' => '100',
      'ccTLD'              => '.bg',
      'name_EN'            => 'Bulgaria',
      'name_DE'            => 'Bulgarien',
      'name_ES'            => 'Bulgaria',
      'name_FR'            => 'Bulgarie',
      'name_IT'            => 'Bulgaria',
      'name_PT'            => 'Bulgária'
      ),
    'BH' => array(
      'iso_3166_1_alpha_3' => 'BHR',
      'iso_3166_1_numeric' => '48',
      'ccTLD'              => '.bh',
      'name_EN'            => 'Bahrain',
      'name_DE'            => 'Bahrain',
      'name_ES'            => 'Bahréin',
      'name_FR'            => 'Bahreïn',
      'name_IT'            => 'Bahrain',
      'name_PT'            => 'Bahrain'
      ),
    'BI' => array(
      'iso_3166_1_alpha_3' => 'BDI',
      'iso_3166_1_numeric' => '108',
      'ccTLD'              => '.bi',
      'name_EN'            => 'Burundi',
      'name_DE'            => 'Burundi',
      'name_ES'            => 'Burundi',
      'name_FR'            => 'Burundi',
      'name_IT'            => 'Burundi',
      'name_PT'            => 'Burundi'
      ),
    'BJ' => array(
      'iso_3166_1_alpha_3' => 'BEN',
      'iso_3166_1_numeric' => '204',
      'ccTLD'              => '.bj',
      'name_EN'            => 'Benin',
      'name_DE'            => 'Benin',
      'name_ES'            => 'Benín',
      'name_FR'            => 'Bénin',
      'name_IT'            => 'Benin',
      'name_PT'            => 'Benin'
      ),
    'BM' => array(
      'iso_3166_1_alpha_3' => 'BMU',
      'iso_3166_1_numeric' => '60',
      'ccTLD'              => '.bm',
      'name_EN'            => 'Bermuda',
      'name_DE'            => 'Bermuda',
      'name_ES'            => 'Bermudas',
      'name_FR'            => 'Bermudes',
      'name_IT'            => 'Bermuda',
      'name_PT'            => 'Bermuda'
      ),
    'BN' => array(
      'iso_3166_1_alpha_3' => 'BRN',
      'iso_3166_1_numeric' => '96',
      'ccTLD'              => '.bn',
      'name_EN'            => 'Brunei Darussalam',
      'name_DE'            => 'Brunei Darussalam',
      'name_ES'            => 'Brunéi',
      'name_FR'            => 'Brunei',
      'name_IT'            => 'Brunei Darussalam',
      'name_PT'            => 'Brunei'
      ),
    'BO' => array(
      'iso_3166_1_alpha_3' => 'BOL',
      'iso_3166_1_numeric' => '68',
      'ccTLD'              => '.bo',
      'name_EN'            => 'Bolivia',
      'name_DE'            => 'Bolivien',
      'name_ES'            => 'Bolivia',
      'name_FR'            => 'Bolivie',
      'name_IT'            => 'Bolivia',
      'name_PT'            => 'Bolívia'
      ),
    'BR' => array(
      'iso_3166_1_alpha_3' => 'BRA',
      'iso_3166_1_numeric' => '76',
      'ccTLD'              => '.br',
      'name_EN'            => 'Brazil',
      'name_DE'            => 'Brasilien',
      'name_ES'            => 'Brasil',
      'name_FR'            => 'Brésil',
      'name_IT'            => 'Brasile',
      'name_PT'            => 'Brasil'
      ),
    'BS' => array(
      'iso_3166_1_alpha_3' => 'BHS',
      'iso_3166_1_numeric' => '44',
      'ccTLD'              => '.bs',
      'name_EN'            => 'Bahamas',
      'name_DE'            => 'Bahamas',
      'name_ES'            => 'Bahamas',
      'name_FR'            => 'Bahamas',
      'name_IT'            => 'Bahamas',
      'name_PT'            => 'Bahamas'
      ),
    'BT' => array(
      'iso_3166_1_alpha_3' => 'BTN',
      'iso_3166_1_numeric' => '64',
      'ccTLD'              => '.bt',
      'name_EN'            => 'Bhutan',
      'name_DE'            => 'Bhutan',
      'name_ES'            => 'Bután',
      'name_FR'            => 'Bhoutan',
      'name_IT'            => 'Bhutan',
      'name_PT'            => 'Butão'
      ),
    'BV' => array(
      'iso_3166_1_alpha_3' => 'BVT',
      'iso_3166_1_numeric' => '74',
      'ccTLD'              => '.bv',
      'name_EN'            => 'Bouvet Island',
      'name_DE'            => 'Bouvetinsel',
      'name_ES'            => 'Isla Bouvet',
      'name_FR'            => 'Île Bouvet',
      'name_IT'            => 'Isola Bouvet',
      'name_PT'            => 'Ilha Bouvet'
      ),
    'BW' => array(
      'iso_3166_1_alpha_3' => 'BWA',
      'iso_3166_1_numeric' => '72',
      'ccTLD'              => '.bw',
      'name_EN'            => 'Botswana',
      'name_DE'            => 'Botswana',
      'name_ES'            => 'Botsuana',
      'name_FR'            => 'Botswana',
      'name_IT'            => 'Botswana',
      'name_PT'            => 'Botswana'
      ),
    'BY' => array(
      'iso_3166_1_alpha_3' => 'BLR',
      'iso_3166_1_numeric' => '112',
      'ccTLD'              => '.by',
      'name_EN'            => 'Belarus',
      'name_DE'            => 'Belarus (Weißrussland)',
      'name_ES'            => 'Bielorrusia',
      'name_FR'            => 'Biélorussie',
      'name_IT'            => 'Bielorussia',
      'name_PT'            => 'Bielo-Rússia'
      ),
    'BZ' => array(
      'iso_3166_1_alpha_3' => 'BLZ',
      'iso_3166_1_numeric' => '84',
      'ccTLD'              => '.bz',
      'name_EN'            => 'Belize',
      'name_DE'            => 'Belize',
      'name_ES'            => 'Belice',
      'name_FR'            => 'Belize',
      'name_IT'            => 'Belize',
      'name_PT'            => 'Belize'
      ),
    'CA' => array(
      'iso_3166_1_alpha_3' => 'CAN',
      'iso_3166_1_numeric' => '124',
      'ccTLD'              => '.ca',
      'name_EN'            => 'Canada',
      'name_DE'            => 'Kanada',
      'name_ES'            => 'Canadá',
      'name_FR'            => 'Canada',
      'name_IT'            => 'Canada',
      'name_PT'            => 'Canadá'
      ),
    'CC' => array(
      'iso_3166_1_alpha_3' => 'CCK',
      'iso_3166_1_numeric' => '166',
      'ccTLD'              => '.cc',
      'name_EN'            => 'Cocos (Keeling) Islands',
      'name_DE'            => 'Kokosinseln',
      'name_ES'            => 'Islas Cocos',
      'name_FR'            => 'Îles Cocos',
      'name_IT'            => 'Isole Cocos',
      'name_PT'            => 'Ilhas Cocos'
      ),
    'CD' => array(
      'iso_3166_1_alpha_3' => 'COD',
      'iso_3166_1_numeric' => '180',
      'ccTLD'              => '.cd',
      'name_EN'            => 'Congo, Democratic Republic of the',
      'name_DE'            => 'Zaire (jetzt Demokratische Republik Kongo)',
      'name_ES'            => 'República Democrática del Congo',
      'name_FR'            => 'Congo-Kinshasa / (République démocratique du Congo)',
      'name_IT'            => 'Repubblica Democratica del Congo',
      'name_PT'            => 'República Democrática do Congo'
      ),
    'CF' => array(
      'iso_3166_1_alpha_3' => 'CAF',
      'iso_3166_1_numeric' => '140',
      'ccTLD'              => '.cf',
      'name_EN'            => 'Central African Republic',
      'name_DE'            => 'Zentralafrikanische Republik',
      'name_ES'            => 'República Centroafricana',
      'name_FR'            => 'Centrafrique',
      'name_IT'            => 'Repubblica Centroafricana',
      'name_PT'            => 'República Centro-africana'
      ),
    'CG' => array(
      'iso_3166_1_alpha_3' => 'COG',
      'iso_3166_1_numeric' => '178',
      'ccTLD'              => '.cg',
      'name_EN'            => 'Congo',
      'name_DE'            => 'Republik Kongo',
      'name_ES'            => 'República del Congo',
      'name_FR'            => 'Congo-Brazzaville / (Congo)',
      'name_IT'            => 'Repubblica del Congo',
      'name_PT'            => 'República do Congo'
      ),
    'CH' => array(
      'iso_3166_1_alpha_3' => 'CHE',
      'iso_3166_1_numeric' => '756',
      'ccTLD'              => '.ch',
      'name_EN'            => 'Switzerland',
      'name_DE'            => 'Schweiz',
      'name_ES'            => 'Suiza',
      'name_FR'            => 'Suisse',
      'name_IT'            => 'Svizzera',
      'name_PT'            => 'Suíça'
      ),
    'CI' => array(
      'iso_3166_1_alpha_3' => 'CIV',
      'iso_3166_1_numeric' => '384',
      'ccTLD'              => '.ci',
      'name_EN'            => 'Côte d\'Ivoire',
      'name_DE'            => 'Elfenbeinküste',
      'name_ES'            => 'Costa de Marfil',
      'name_FR'            => 'Côte d\'Ivoire ',
      'name_IT'            => 'Costa d\'Avorio',
      'name_PT'            => 'Costa do Marfim'
      ),
    'CK' => array(
      'iso_3166_1_alpha_3' => 'COK',
      'iso_3166_1_numeric' => '184',
      'ccTLD'              => '.ck',
      'name_EN'            => 'Cook Islands',
      'name_DE'            => 'Cookinseln',
      'name_ES'            => 'Islas Cook',
      'name_FR'            => 'Îles Cook',
      'name_IT'            => 'Isole Cook',
      'name_PT'            => 'Ilhas Cook'
      ),
    'CL' => array(
      'iso_3166_1_alpha_3' => 'CHL',
      'iso_3166_1_numeric' => '152',
      'ccTLD'              => '.cl',
      'name_EN'            => 'Chile',
      'name_DE'            => 'Chile',
      'name_ES'            => 'Chile',
      'name_FR'            => 'Chili',
      'name_IT'            => 'Cile',
      'name_PT'            => 'Chile'
      ),
    'CM' => array(
      'iso_3166_1_alpha_3' => 'CMR',
      'iso_3166_1_numeric' => '120',
      'ccTLD'              => '.cm',
      'name_EN'            => 'Cameroon',
      'name_DE'            => 'Kamerun',
      'name_ES'            => 'Camerún',
      'name_FR'            => 'Cameroun',
      'name_IT'            => 'Camerun',
      'name_PT'            => 'Camarões'
      ),
    'CN' => array(
      'iso_3166_1_alpha_3' => 'CHN',
      'iso_3166_1_numeric' => '156',
      'ccTLD'              => '.cn',
      'name_EN'            => 'China',
      'name_DE'            => 'China, Volksrepublik',
      'name_ES'            => 'China',
      'name_FR'            => 'Chine',
      'name_IT'            => 'Cina',
      'name_PT'            => 'China'
      ),
    'CO' => array(
      'iso_3166_1_alpha_3' => 'COL',
      'iso_3166_1_numeric' => '170',
      'ccTLD'              => '.co',
      'name_EN'            => 'Colombia',
      'name_DE'            => 'Kolumbien',
      'name_ES'            => 'Colombia',
      'name_FR'            => 'Colombie',
      'name_IT'            => 'Colombia',
      'name_PT'            => 'Colômbia'
      ),
    'CR' => array(
      'iso_3166_1_alpha_3' => 'CRI',
      'iso_3166_1_numeric' => '188',
      'ccTLD'              => '.cr',
      'name_EN'            => 'Costa Rica',
      'name_DE'            => 'Costa Rica',
      'name_ES'            => 'Costa Rica',
      'name_FR'            => 'Costa Rica',
      'name_IT'            => 'Costa Rica',
      'name_PT'            => 'Costa Rica'
      ),
    'CU' => array(
      'iso_3166_1_alpha_3' => 'CUB',
      'iso_3166_1_numeric' => '192',
      'ccTLD'              => '.cu',
      'name_EN'            => 'Cuba',
      'name_DE'            => 'Kuba',
      'name_ES'            => 'Cuba',
      'name_FR'            => 'Cuba',
      'name_IT'            => 'Cuba',
      'name_PT'            => 'Cuba'
      ),
    'CV' => array(
      'iso_3166_1_alpha_3' => 'CPV',
      'iso_3166_1_numeric' => '132',
      'ccTLD'              => '.cv',
      'name_EN'            => 'Cape Verde',
      'name_DE'            => 'Kap Verde',
      'name_ES'            => 'Cabo Verde',
      'name_FR'            => 'Cap-Vert',
      'name_IT'            => 'Capo Verde',
      'name_PT'            => 'Cabo Verde'
      ),
    'CX' => array(
      'iso_3166_1_alpha_3' => 'CXR',
      'iso_3166_1_numeric' => '162',
      'ccTLD'              => '.cx',
      'name_EN'            => 'Christmas Island',
      'name_DE'            => 'Weihnachtsinsel',
      'name_ES'            => 'Isla de Navidad',
      'name_FR'            => 'Île Christmas',
      'name_IT'            => 'Isola di Natale',
      'name_PT'            => 'Ilha Christmas'
      ),
    'CY' => array(
      'iso_3166_1_alpha_3' => 'CYP',
      'iso_3166_1_numeric' => '196',
      'ccTLD'              => '.cy',
      'name_EN'            => 'Cyprus',
      'name_DE'            => 'Zypern',
      'name_ES'            => 'Chipre',
      'name_FR'            => 'Chypre (pays)||CHYPRE',
      'name_IT'            => 'Cipro',
      'name_PT'            => 'Chipre'
      ),
    'CZ' => array(
      'iso_3166_1_alpha_3' => 'CZE',
      'iso_3166_1_numeric' => '203',
      'ccTLD'              => '.cz',
      'name_EN'            => 'Czech Republic',
      'name_DE'            => 'Tschechische Republik',
      'name_ES'            => 'República Checa',
      'name_FR'            => 'République tchèque',
      'name_IT'            => 'Repubblica Ceca',
      'name_PT'            => 'República Checa'
      ),
    'DE' => array(
      'iso_3166_1_alpha_3' => 'DEU',
      'iso_3166_1_numeric' => '276',
      'ccTLD'              => '.de',
      'name_EN'            => 'Germany',
      'name_DE'            => 'Deutschland',
      'name_ES'            => 'Alemania',
      'name_FR'            => 'Allemagne',
      'name_IT'            => 'Germania',
      'name_PT'            => 'Alemanha'
      ),
    'DJ' => array(
      'iso_3166_1_alpha_3' => 'DJI',
      'iso_3166_1_numeric' => '262',
      'ccTLD'              => '.dj',
      'name_EN'            => 'Djibouti',
      'name_DE'            => 'Dschibuti',
      'name_ES'            => 'Yibuti',
      'name_FR'            => 'Djibouti',
      'name_IT'            => 'Gibuti',
      'name_PT'            => 'Djibouti'
      ),
    'DK' => array(
      'iso_3166_1_alpha_3' => 'DNK',
      'iso_3166_1_numeric' => '208',
      'ccTLD'              => '.dk',
      'name_EN'            => 'Denmark',
      'name_DE'            => 'Dänemark',
      'name_ES'            => 'Dinamarca',
      'name_FR'            => 'Danemark',
      'name_IT'            => 'Danimarca',
      'name_PT'            => 'Dinamarca'
      ),
    'DM' => array(
      'iso_3166_1_alpha_3' => 'DMA',
      'iso_3166_1_numeric' => '212',
      'ccTLD'              => '.dm',
      'name_EN'            => 'Dominica',
      'name_DE'            => 'Dominica',
      'name_ES'            => 'Dominica',
      'name_FR'            => 'Dominique',
      'name_IT'            => 'Dominica',
      'name_PT'            => 'Dominica'
      ),
    'DO' => array(
      'iso_3166_1_alpha_3' => 'DOM',
      'iso_3166_1_numeric' => '214',
      'ccTLD'              => '.do',
      'name_EN'            => 'Dominican Republic',
      'name_DE'            => 'Dominikanische Republik',
      'name_ES'            => 'República Dominicana',
      'name_FR'            => 'République dominicaine',
      'name_IT'            => 'Repubblica Dominicana',
      'name_PT'            => 'República Dominicana'
      ),
    'DZ' => array(
      'iso_3166_1_alpha_3' => 'DZA',
      'iso_3166_1_numeric' => '12',
      'ccTLD'              => '.dz',
      'name_EN'            => 'Algeria',
      'name_DE'            => 'Algerien',
      'name_ES'            => 'Argelia',
      'name_FR'            => 'Algérie',
      'name_IT'            => 'Algeria',
      'name_PT'            => 'Argélia'
      ),
    'EC' => array(
      'iso_3166_1_alpha_3' => 'ECU',
      'iso_3166_1_numeric' => '218',
      'ccTLD'              => '.ec',
      'name_EN'            => 'Ecuador',
      'name_DE'            => 'Ecuador',
      'name_ES'            => 'Ecuador',
      'name_FR'            => 'Équateur',
      'name_IT'            => 'Ecuador',
      'name_PT'            => 'Equador'
      ),
    'EE' => array(
      'iso_3166_1_alpha_3' => 'EST',
      'iso_3166_1_numeric' => '233',
      'ccTLD'              => '.ee',
      'name_EN'            => 'Estonia',
      'name_DE'            => 'Estland',
      'name_ES'            => 'Estonia',
      'name_FR'            => 'Estonie',
      'name_IT'            => 'Estonia',
      'name_PT'            => 'Estónia'
      ),
    'EG' => array(
      'iso_3166_1_alpha_3' => 'EGY',
      'iso_3166_1_numeric' => '818',
      'ccTLD'              => '.eg',
      'name_EN'            => 'Egypt',
      'name_DE'            => 'Ägypten',
      'name_ES'            => 'Egipto',
      'name_FR'            => 'Égypte',
      'name_IT'            => 'Egitto',
      'name_PT'            => 'Egipto'
      ),
    'EH' => array(
      'iso_3166_1_alpha_3' => 'ESH',
      'iso_3166_1_numeric' => '732',
      'ccTLD'              => '.eh',
      'name_EN'            => 'Western Sahara',
      'name_DE'            => 'Westsahara',
      'name_ES'            => 'Sahara Occidental',
      'name_FR'            => 'Sahara occidental',
      'name_IT'            => 'Sahara Occidentale',
      'name_PT'            => 'Saara Ocidental'
      ),
    'ER' => array(
      'iso_3166_1_alpha_3' => 'ERI',
      'iso_3166_1_numeric' => '232',
      'ccTLD'              => '.er',
      'name_EN'            => 'Eritrea',
      'name_DE'            => 'Eritrea',
      'name_ES'            => 'Eritrea',
      'name_FR'            => 'Érythrée',
      'name_IT'            => 'Eritrea',
      'name_PT'            => 'Eritreia'
      ),
    'ES' => array(
      'iso_3166_1_alpha_3' => 'ESP',
      'iso_3166_1_numeric' => '724',
      'ccTLD'              => '.es',
      'name_EN'            => 'Spain',
      'name_DE'            => 'Spanien',
      'name_ES'            => 'España(Ceuta y Melilla)',
      'name_FR'            => 'Espagne',
      'name_IT'            => 'Spagna',
      'name_PT'            => 'Espanha'
      ),
    'ET' => array(
      'iso_3166_1_alpha_3' => 'ETH',
      'iso_3166_1_numeric' => '231',
      'ccTLD'              => '.et',
      'name_EN'            => 'Ethiopia',
      'name_DE'            => 'Äthiopien',
      'name_ES'            => 'Etiopía',
      'name_FR'            => 'Éthiopie',
      'name_IT'            => 'Etiopia',
      'name_PT'            => 'Etiópia'
      ),
    'FI' => array(
      'iso_3166_1_alpha_3' => 'FIN',
      'iso_3166_1_numeric' => '246',
      'ccTLD'              => '.fi',
      'name_EN'            => 'Finland',
      'name_DE'            => 'Finnland',
      'name_ES'            => 'Finlandia',
      'name_FR'            => 'Finlande',
      'name_IT'            => 'Finlandia',
      'name_PT'            => 'Finlândia'
      ),
    'FJ' => array(
      'iso_3166_1_alpha_3' => 'FJI',
      'iso_3166_1_numeric' => '242',
      'ccTLD'              => '.fj',
      'name_EN'            => 'Fiji',
      'name_DE'            => 'Fidschi',
      'name_ES'            => 'Fiyi',
      'name_FR'            => 'Fidji',
      'name_IT'            => 'Fiji',
      'name_PT'            => 'Fiji'
      ),
    'FK' => array(
      'iso_3166_1_alpha_3' => 'FLK',
      'iso_3166_1_numeric' => '238',
      'ccTLD'              => '.fk',
      'name_EN'            => 'Falkland Islands (Malvinas)',
      'name_DE'            => 'Falklandinseln',
      'name_ES'            => 'Islas Malvinas',
      'name_FR'            => 'Îles Malouines',
      'name_IT'            => 'Isole Falkland',
      'name_PT'            => 'Ilhas Malvinas'
      ),
    'FM' => array(
      'iso_3166_1_alpha_3' => 'FSM',
      'iso_3166_1_numeric' => '583',
      'ccTLD'              => '.fm',
      'name_EN'            => 'Micronesia, Federated States of',
      'name_DE'            => 'Mikronesien',
      'name_ES'            => 'Micronesia',
      'name_FR'            => 'Micronésie (pays)',
      'name_IT'            => 'Stati Federati della Micronesia',
      'name_PT'            => 'Estados Federados da Micronésia'
      ),
    'FO' => array(
      'iso_3166_1_alpha_3' => 'FRO',
      'iso_3166_1_numeric' => '234',
      'ccTLD'              => '.fo',
      'name_EN'            => 'Faroe Islands',
      'name_DE'            => 'Färöer',
      'name_ES'            => 'Islas Feroe',
      'name_FR'            => 'Îles Féroé',
      'name_IT'            => 'Isole Faroe',
      'name_PT'            => 'Ilhas Faroe'
      ),
    'FR' => array(
      'iso_3166_1_alpha_3' => 'FRA',
      'iso_3166_1_numeric' => '250',
      'ccTLD'              => '.fr',
      'name_EN'            => 'France',
      'name_DE'            => 'Frankreich',
      'name_ES'            => 'Francia',
      'name_FR'            => 'France',
      'name_IT'            => 'Francia',
      'name_PT'            => 'França'
      ),
    'GA' => array(
      'iso_3166_1_alpha_3' => 'GAB',
      'iso_3166_1_numeric' => '266',
      'ccTLD'              => '.ga',
      'name_EN'            => 'Gabon',
      'name_DE'            => 'Gabun',
      'name_ES'            => 'Gabón',
      'name_FR'            => 'Gabon',
      'name_IT'            => 'Gabon',
      'name_PT'            => 'Gabão'
      ),
    'GB' => array(
      'iso_3166_1_alpha_3' => 'GBR',
      'iso_3166_1_numeric' => '826',
      'ccTLD'              => '.uk',
      'name_EN'            => 'United Kingdom',
      'name_DE'            => 'Vereinigtes Königreich Großbritannien und Nordirland',
      'name_ES'            => 'Reino Unido',
      'name_FR'            => 'Royaume-Uni',
      'name_IT'            => 'Regno Unito',
      'name_PT'            => 'Reino Unido'
      ),
    'GD' => array(
      'iso_3166_1_alpha_3' => 'GRD',
      'iso_3166_1_numeric' => '308',
      'ccTLD'              => '.gd',
      'name_EN'            => 'Grenada',
      'name_DE'            => 'Grenada',
      'name_ES'            => 'Granada',
      'name_FR'            => 'Grenade (pays)||GRENADE',
      'name_IT'            => 'Grenada',
      'name_PT'            => 'Grenada'
      ),
    'GE' => array(
      'iso_3166_1_alpha_3' => 'GEO',
      'iso_3166_1_numeric' => '268',
      'ccTLD'              => '.ge',
      'name_EN'            => 'Georgia',
      'name_DE'            => 'Georgien',
      'name_ES'            => 'Georgia',
      'name_FR'            => 'Géorgie (pays)',
      'name_IT'            => 'Georgia',
      'name_PT'            => 'Geórgia'
      ),
    'GF' => array(
      'iso_3166_1_alpha_3' => 'GUF',
      'iso_3166_1_numeric' => '254',
      'ccTLD'              => '.gf',
      'name_EN'            => 'French Guiana',
      'name_DE'            => 'Französisch-Guayana',
      'name_ES'            => 'Guayana Francesa',
      'name_FR'            => 'Guyane',
      'name_IT'            => 'Guyana Francese',
      'name_PT'            => 'Guiana Francesa'
      ),
    'GG' => array(
      'iso_3166_1_alpha_3' => 'GGY',
      'iso_3166_1_numeric' => '831',
      'ccTLD'              => '.gg',
      'name_EN'            => 'Guernsey',
      'name_DE'            => 'Guernsey (Kanalinsel)',
      'name_ES'            => 'Guernsey',
      'name_FR'            => 'Guernesey',
      'name_IT'            => 'Guernsey',
      'name_PT'            => 'Guernsey'
      ),
    'GH' => array(
      'iso_3166_1_alpha_3' => 'GHA',
      'iso_3166_1_numeric' => '288',
      'ccTLD'              => '.gh',
      'name_EN'            => 'Ghana',
      'name_DE'            => 'Ghana',
      'name_ES'            => 'Ghana',
      'name_FR'            => 'Ghana',
      'name_IT'            => 'Ghana',
      'name_PT'            => 'Gana'
      ),
    'GI' => array(
      'iso_3166_1_alpha_3' => 'GIB',
      'iso_3166_1_numeric' => '292',
      'ccTLD'              => '.gi',
      'name_EN'            => 'Gibraltar',
      'name_DE'            => 'Gibraltar',
      'name_ES'            => 'Gibraltar',
      'name_FR'            => 'Gibraltar',
      'name_IT'            => 'Gibilterra',
      'name_PT'            => 'Gibraltar'
      ),
    'GL' => array(
      'iso_3166_1_alpha_3' => 'GRL',
      'iso_3166_1_numeric' => '304',
      'ccTLD'              => '.gl',
      'name_EN'            => 'Greenland',
      'name_DE'            => 'Grönland',
      'name_ES'            => 'Groenlandia',
      'name_FR'            => 'Groenland',
      'name_IT'            => 'Groenlandia',
      'name_PT'            => 'Gronelândia'
      ),
    'GM' => array(
      'iso_3166_1_alpha_3' => 'GMB',
      'iso_3166_1_numeric' => '270',
      'ccTLD'              => '.gm',
      'name_EN'            => 'Gambia',
      'name_DE'            => 'Gambia',
      'name_ES'            => 'Gambia',
      'name_FR'            => 'Gambie',
      'name_IT'            => 'Gambia',
      'name_PT'            => 'Gâmbia'
      ),
    'GN' => array(
      'iso_3166_1_alpha_3' => 'GIN',
      'iso_3166_1_numeric' => '324',
      'ccTLD'              => '.gn',
      'name_EN'            => 'Guinea',
      'name_DE'            => 'Guinea',
      'name_ES'            => 'Guinea',
      'name_FR'            => 'Guinée',
      'name_IT'            => 'Guinea',
      'name_PT'            => 'Guiné-Conacri'
      ),
    'GP' => array(
      'iso_3166_1_alpha_3' => 'GLP',
      'iso_3166_1_numeric' => '312',
      'ccTLD'              => '.gp',
      'name_EN'            => 'Guadeloupe[1]',
      'name_DE'            => 'Guadeloupe',
      'name_ES'            => 'Guadalupe',
      'name_FR'            => 'Guadeloupe',
      'name_IT'            => 'Guadalupa',
      'name_PT'            => 'Guadeloupe'
      ),
    'GQ' => array(
      'iso_3166_1_alpha_3' => 'GNQ',
      'iso_3166_1_numeric' => '226',
      'ccTLD'              => '.gq',
      'name_EN'            => 'Equatorial Guinea',
      'name_DE'            => 'Äquatorialguinea',
      'name_ES'            => 'Guinea Ecuatorial',
      'name_FR'            => 'Guinée équatoriale',
      'name_IT'            => 'Guinea Equatoriale',
      'name_PT'            => 'Guiné Equatorial'
      ),
    'GR' => array(
      'iso_3166_1_alpha_3' => 'GRC',
      'iso_3166_1_numeric' => '300',
      'ccTLD'              => '.gr',
      'name_EN'            => 'Greece',
      'name_DE'            => 'Griechenland',
      'name_ES'            => 'Grecia',
      'name_FR'            => 'Grèce',
      'name_IT'            => 'Grecia',
      'name_PT'            => 'Grécia '
      ),
    'GS' => array(
      'iso_3166_1_alpha_3' => 'SGS',
      'iso_3166_1_numeric' => '239',
      'ccTLD'              => '.gs',
      'name_EN'            => 'South Georgia and the South Sandwich Islands',
      'name_DE'            => 'Südgeorgien und die Südlichen Sandwichinseln',
      'name_ES'            => 'Islas Georgias del Sur y Sandwich del Sur',
      'name_FR'            => 'Géorgie du Sud et les îles Sandwich du Sud',
      'name_IT'            => 'Sud Georgia e Isole Sandwich',
      'name_PT'            => 'Ilhas Geórgia do Sul e Sandwich do Sul'
      ),
    'GT' => array(
      'iso_3166_1_alpha_3' => 'GTM',
      'iso_3166_1_numeric' => '320',
      'ccTLD'              => '.gt',
      'name_EN'            => 'Guatemala',
      'name_DE'            => 'Guatemala',
      'name_ES'            => 'Guatemala',
      'name_FR'            => 'Guatemala',
      'name_IT'            => 'Guatemala',
      'name_PT'            => 'Guatemala'
      ),
    'GU' => array(
      'iso_3166_1_alpha_3' => 'GUM',
      'iso_3166_1_numeric' => '316',
      'ccTLD'              => '.gu',
      'name_EN'            => 'Guam',
      'name_DE'            => 'Guam',
      'name_ES'            => 'Guam',
      'name_FR'            => 'Guam',
      'name_IT'            => 'Guam',
      'name_PT'            => 'Guam'
      ),
    'GW' => array(
      'iso_3166_1_alpha_3' => 'GNB',
      'iso_3166_1_numeric' => '624',
      'ccTLD'              => '.gw',
      'name_EN'            => 'Guinea-Bissau',
      'name_DE'            => 'Guinea-Bissau',
      'name_ES'            => 'Guinea-Bissau',
      'name_FR'            => 'Guinée-Bissau',
      'name_IT'            => 'Guinea-Bissau',
      'name_PT'            => 'Guiné-Bissau'
      ),
    'GY' => array(
      'iso_3166_1_alpha_3' => 'GUY',
      'iso_3166_1_numeric' => '328',
      'ccTLD'              => '.gy',
      'name_EN'            => 'Guyana',
      'name_DE'            => 'Guyana',
      'name_ES'            => 'Guyana',
      'name_FR'            => 'Guyana',
      'name_IT'            => 'Guyana',
      'name_PT'            => 'Guiana'
      ),
    'HK' => array(
      'iso_3166_1_alpha_3' => 'HKG',
      'iso_3166_1_numeric' => '344',
      'ccTLD'              => '.hk',
      'name_EN'            => 'Hong Kong',
      'name_DE'            => 'Hongkong',
      'name_ES'            => 'Hong Kong',
      'name_FR'            => 'Hong Kong',
      'name_IT'            => 'Hong Kong',
      'name_PT'            => 'Hong Kong'
      ),
    'HM' => array(
      'iso_3166_1_alpha_3' => 'HMD',
      'iso_3166_1_numeric' => '334',
      'ccTLD'              => '.hm',
      'name_EN'            => 'Heard Island and McDonald Islands',
      'name_DE'            => 'Heard- und McDonald-Inseln',
      'name_ES'            => 'Islas Heard y McDonald',
      'name_FR'            => 'Île Heard et îles McDonald',
      'name_IT'            => 'Isole Heard e McDonald',
      'name_PT'            => 'Ilha Heard e Ilhas McDonald'
      ),
    'HN' => array(
      'iso_3166_1_alpha_3' => 'HND',
      'iso_3166_1_numeric' => '340',
      'ccTLD'              => '.hn',
      'name_EN'            => 'Honduras',
      'name_DE'            => 'Honduras',
      'name_ES'            => 'Honduras',
      'name_FR'            => 'Honduras',
      'name_IT'            => 'Honduras',
      'name_PT'            => 'Honduras'
      ),
    'HR' => array(
      'iso_3166_1_alpha_3' => 'HRV',
      'iso_3166_1_numeric' => '191',
      'ccTLD'              => '.hr',
      'name_EN'            => 'Croatia',
      'name_DE'            => 'Kroatien',
      'name_ES'            => 'Croacia',
      'name_FR'            => 'Croatie',
      'name_IT'            => 'Croazia',
      'name_PT'            => 'Croácia'
      ),
    'HT' => array(
      'iso_3166_1_alpha_3' => 'HTI',
      'iso_3166_1_numeric' => '332',
      'ccTLD'              => '.ht',
      'name_EN'            => 'Haiti',
      'name_DE'            => 'Haiti',
      'name_ES'            => 'Haití',
      'name_FR'            => 'Haïti',
      'name_IT'            => 'Haiti',
      'name_PT'            => 'Haiti'
      ),
    'HU' => array(
      'iso_3166_1_alpha_3' => 'HUN',
      'iso_3166_1_numeric' => '348',
      'ccTLD'              => '.hu',
      'name_EN'            => 'Hungary',
      'name_DE'            => 'Ungarn',
      'name_ES'            => 'Hungría',
      'name_FR'            => 'Hongrie',
      'name_IT'            => 'Ungheria',
      'name_PT'            => 'Hungria'
      ),
    'ID' => array(
      'iso_3166_1_alpha_3' => 'IDN',
      'iso_3166_1_numeric' => '360',
      'ccTLD'              => '.id',
      'name_EN'            => 'Indonesia',
      'name_DE'            => 'Indonesien',
      'name_ES'            => 'Indonesia',
      'name_FR'            => 'Indonésie',
      'name_IT'            => 'Indonesia',
      'name_PT'            => 'Indonésia'
      ),
    'IE' => array(
      'iso_3166_1_alpha_3' => 'IRL',
      'iso_3166_1_numeric' => '372',
      'ccTLD'              => '.ie',
      'name_EN'            => 'Ireland',
      'name_DE'            => 'Irland',
      'name_ES'            => 'Irlanda',
      'name_FR'            => 'Irlande (pays)||IRLANDE',
      'name_IT'            => 'Eire',
      'name_PT'            => 'Irlanda'
      ),
    'IL' => array(
      'iso_3166_1_alpha_3' => 'ISR',
      'iso_3166_1_numeric' => '376',
      'ccTLD'              => '.il',
      'name_EN'            => 'Israel',
      'name_DE'            => 'Israel',
      'name_ES'            => 'Israel',
      'name_FR'            => 'Israël',
      'name_IT'            => 'Israele',
      'name_PT'            => 'Israel'
      ),
    'IM' => array(
      'iso_3166_1_alpha_3' => 'IMN',
      'iso_3166_1_numeric' => '833',
      'ccTLD'              => '.im',
      'name_EN'            => 'Isle of Man',
      'name_DE'            => 'Insel Man',
      'name_ES'            => 'Isla de Man',
      'name_FR'            => 'Île de Man',
      'name_IT'            => 'Isola di Man',
      'name_PT'            => 'Ilha de Man'
      ),
    'IN' => array(
      'iso_3166_1_alpha_3' => 'IND',
      'iso_3166_1_numeric' => '356',
      'ccTLD'              => '.in',
      'name_EN'            => 'India',
      'name_DE'            => 'Indien',
      'name_ES'            => 'India',
      'name_FR'            => 'Inde',
      'name_IT'            => 'India',
      'name_PT'            => 'Índia'
      ),
    'IO' => array(
      'iso_3166_1_alpha_3' => 'IOT',
      'iso_3166_1_numeric' => '86',
      'ccTLD'              => '.io',
      'name_EN'            => 'British Indian Ocean Territory',
      'name_DE'            => 'Britisches Territorium im Indischen Ozean',
      'name_ES'            => 'Territorio Británico del Océano Índico',
      'name_FR'            => 'Territoire britannique de l\'océan Indien',
      'name_IT'            => 'Territorio Britannico dell\'Oceano Indiano',
      'name_PT'            => 'Território Britânico do Oceano Índico'
      ),
    'IQ' => array(
      'iso_3166_1_alpha_3' => 'IRQ',
      'iso_3166_1_numeric' => '368',
      'ccTLD'              => '.iq',
      'name_EN'            => 'Iraq',
      'name_DE'            => 'Irak',
      'name_ES'            => 'Iraq',
      'name_FR'            => 'Irak',
      'name_IT'            => 'Iraq',
      'name_PT'            => 'Iraque'
      ),
    'IR' => array(
      'iso_3166_1_alpha_3' => 'IRN',
      'iso_3166_1_numeric' => '364',
      'ccTLD'              => '.ir',
      'name_EN'            => 'Iran, Islamic Republic of',
      'name_DE'            => 'Iran',
      'name_ES'            => 'Irán',
      'name_FR'            => 'Iran',
      'name_IT'            => 'Iran',
      'name_PT'            => 'Irão'
      ),
    'IS' => array(
      'iso_3166_1_alpha_3' => 'ISL',
      'iso_3166_1_numeric' => '352',
      'ccTLD'              => '.is',
      'name_EN'            => 'Iceland',
      'name_DE'            => 'Island',
      'name_ES'            => 'Islandia',
      'name_FR'            => 'Islande',
      'name_IT'            => 'Islanda',
      'name_PT'            => 'Islândia'
      ),
    'IT' => array(
      'iso_3166_1_alpha_3' => 'ITA',
      'iso_3166_1_numeric' => '380',
      'ccTLD'              => '.it',
      'name_EN'            => 'Italy',
      'name_DE'            => 'Italien',
      'name_ES'            => 'Italia',
      'name_FR'            => 'Italie',
      'name_IT'            => 'Italia',
      'name_PT'            => 'Itália'
      ),
    'JE' => array(
      'iso_3166_1_alpha_3' => 'JEY',
      'iso_3166_1_numeric' => '832',
      'ccTLD'              => '.je',
      'name_EN'            => 'Jersey',
      'name_DE'            => 'Jersey (Kanalinsel)',
      'name_ES'            => 'Jersey',
      'name_FR'            => 'Jersey',
      'name_IT'            => 'Jersey',
      'name_PT'            => 'Jersey'
      ),
    'JM' => array(
      'iso_3166_1_alpha_3' => 'JAM',
      'iso_3166_1_numeric' => '388',
      'ccTLD'              => '.jm',
      'name_EN'            => 'Jamaica',
      'name_DE'            => 'Jamaika',
      'name_ES'            => 'Jamaica',
      'name_FR'            => 'JJamaïque',
      'name_IT'            => 'Giamaica',
      'name_PT'            => 'Jamaica'
      ),
    'JO' => array(
      'iso_3166_1_alpha_3' => 'JOR',
      'iso_3166_1_numeric' => '400',
      'ccTLD'              => '.jo',
      'name_EN'            => 'Jordan',
      'name_DE'            => 'Jordanien',
      'name_ES'            => 'Jordania',
      'name_FR'            => 'Jordanie',
      'name_IT'            => 'Giordania',
      'name_PT'            => 'Jordânia'
      ),
    'JP' => array(
      'iso_3166_1_alpha_3' => 'JPN',
      'iso_3166_1_numeric' => '392',
      'ccTLD'              => '.jp',
      'name_EN'            => 'Japan',
      'name_DE'            => 'Japan',
      'name_ES'            => 'Japón',
      'name_FR'            => 'Japon',
      'name_IT'            => 'Giappone',
      'name_PT'            => 'Japão'
      ),
    'KE' => array(
      'iso_3166_1_alpha_3' => 'KEN',
      'iso_3166_1_numeric' => '404',
      'ccTLD'              => '.ke',
      'name_EN'            => 'Kenya',
      'name_DE'            => 'Kenia',
      'name_ES'            => 'Kenia',
      'name_FR'            => 'Kenya',
      'name_IT'            => 'Kenya',
      'name_PT'            => 'Quénia'
      ),
    'KG' => array(
      'iso_3166_1_alpha_3' => 'KGZ',
      'iso_3166_1_numeric' => '417',
      'ccTLD'              => '.kg',
      'name_EN'            => 'Kyrgyzstan',
      'name_DE'            => 'Kirgisistan',
      'name_ES'            => 'Kirguistán',
      'name_FR'            => 'Kirghizistan',
      'name_IT'            => 'Kirghizistan',
      'name_PT'            => 'Quirguistão'
      ),
    'KH' => array(
      'iso_3166_1_alpha_3' => 'KHM',
      'iso_3166_1_numeric' => '116',
      'ccTLD'              => '.kh',
      'name_EN'            => 'Cambodia',
      'name_DE'            => 'Kambodscha',
      'name_ES'            => 'Camboya',
      'name_FR'            => 'Cambodge',
      'name_IT'            => 'Cambogia',
      'name_PT'            => 'Cambodja'
      ),
    'KI' => array(
      'iso_3166_1_alpha_3' => 'KIR',
      'iso_3166_1_numeric' => '296',
      'ccTLD'              => '.ki',
      'name_EN'            => 'Kiribati',
      'name_DE'            => 'Kiribati',
      'name_ES'            => 'Kiribati',
      'name_FR'            => 'Kiribati',
      'name_IT'            => 'Kiribati',
      'name_PT'            => 'Kiribati'
      ),
    'KM' => array(
      'iso_3166_1_alpha_3' => 'COM',
      'iso_3166_1_numeric' => '174',
      'ccTLD'              => '.km',
      'name_EN'            => 'Comoros',
      'name_DE'            => 'Komoren',
      'name_ES'            => 'Comoras',
      'name_FR'            => 'Comores',
      'name_IT'            => 'Comore',
      'name_PT'            => 'Comores'
      ),
    'KN' => array(
      'iso_3166_1_alpha_3' => 'KNA',
      'iso_3166_1_numeric' => '659',
      'ccTLD'              => '.kn',
      'name_EN'            => 'Saint Kitts and Nevis',
      'name_DE'            => 'St. Kitts und Nevis',
      'name_ES'            => 'San Cristóbal y Nieves',
      'name_FR'            => 'Saint-Christophe-et-Niévès',
      'name_IT'            => 'Saint Kitts e Nevis',
      'name_PT'            => 'São Cristóvão e Névis'
      ),
    'KP' => array(
      'iso_3166_1_alpha_3' => 'PRK',
      'iso_3166_1_numeric' => '408',
      'ccTLD'              => '.kp',
      'name_EN'            => 'Korea, Democratic People\'s Republic of',
      'name_DE'            => 'Nordkorea',
      'name_ES'            => 'Corea del Norte',
      'name_FR'            => 'Corée du Nord',
      'name_IT'            => 'Corea del Nord',
      'name_PT'            => 'Coreia do Norte'
      ),
    'KR' => array(
      'iso_3166_1_alpha_3' => 'KOR',
      'iso_3166_1_numeric' => '410',
      'ccTLD'              => '.kr',
      'name_EN'            => 'Korea, Republic of',
      'name_DE'            => 'Südkorea',
      'name_ES'            => 'Corea del Sur',
      'name_FR'            => 'Corée du Sud',
      'name_IT'            => 'Corea del Sud',
      'name_PT'            => 'Coreia do Sul'
      ),
    'KW' => array(
      'iso_3166_1_alpha_3' => 'KWT',
      'iso_3166_1_numeric' => '414',
      'ccTLD'              => '.kw',
      'name_EN'            => 'Kuwait',
      'name_DE'            => 'Kuwait',
      'name_ES'            => 'Kuwait',
      'name_FR'            => 'Koweït',
      'name_IT'            => 'Kuwait',
      'name_PT'            => 'Kuwait'
      ),
    'KY' => array(
      'iso_3166_1_alpha_3' => 'CYM',
      'iso_3166_1_numeric' => '136',
      'ccTLD'              => '.ky',
      'name_EN'            => 'Cayman Islands',
      'name_DE'            => 'Kaimaninseln',
      'name_ES'            => 'Islas Caimán',
      'name_FR'            => 'Îles Caïmanes',
      'name_IT'            => 'Isole Cayman',
      'name_PT'            => 'Ilhas Cayman'
      ),
    'KZ' => array(
      'iso_3166_1_alpha_3' => 'KAZ',
      'iso_3166_1_numeric' => '398',
      'ccTLD'              => '.kz',
      'name_EN'            => 'Kazakhstan',
      'name_DE'            => 'Kasachstan',
      'name_ES'            => 'Kazajistán',
      'name_FR'            => 'Kazakhstan',
      'name_IT'            => 'Kazakistan',
      'name_PT'            => 'Cazaquistão'
      ),
    'LA' => array(
      'iso_3166_1_alpha_3' => 'LAO',
      'iso_3166_1_numeric' => '418',
      'ccTLD'              => '.la',
      'name_EN'            => 'Lao People\'s Democratic Republic',
      'name_DE'            => 'Laos',
      'name_ES'            => 'Laos',
      'name_FR'            => 'Laos',
      'name_IT'            => 'Laos',
      'name_PT'            => 'Laos'
      ),
    'LB' => array(
      'iso_3166_1_alpha_3' => 'LBN',
      'iso_3166_1_numeric' => '422',
      'ccTLD'              => '.lb',
      'name_EN'            => 'Lebanon',
      'name_DE'            => 'Libanon',
      'name_ES'            => 'Líbano',
      'name_FR'            => 'Liban',
      'name_IT'            => 'Libano',
      'name_PT'            => 'Líbano'
      ),
    'LC' => array(
      'iso_3166_1_alpha_3' => 'LCA',
      'iso_3166_1_numeric' => '662',
      'ccTLD'              => '.lc',
      'name_EN'            => 'Saint Lucia',
      'name_DE'            => 'St. Lucia',
      'name_ES'            => 'Santa Lucía',
      'name_FR'            => 'Sainte-Lucie',
      'name_IT'            => 'Santa Lucia',
      'name_PT'            => 'Santa Lúcia'
      ),
    'LI' => array(
      'iso_3166_1_alpha_3' => 'LIE',
      'iso_3166_1_numeric' => '438',
      'ccTLD'              => '.li',
      'name_EN'            => 'Liechtenstein',
      'name_DE'            => 'Liechtenstein',
      'name_ES'            => 'Liechtenstein',
      'name_FR'            => 'Liechtenstein',
      'name_IT'            => 'Liechtenstein',
      'name_PT'            => 'Liechtenstein'
      ),
    'LK' => array(
      'iso_3166_1_alpha_3' => 'LKA',
      'iso_3166_1_numeric' => '144',
      'ccTLD'              => '.lk',
      'name_EN'            => 'Sri Lanka',
      'name_DE'            => 'Sri Lanka',
      'name_ES'            => 'Sri Lanka',
      'name_FR'            => 'Sri Lanka',
      'name_IT'            => 'Sri Lanka',
      'name_PT'            => 'Sri Lanka'
      ),
    'LR' => array(
      'iso_3166_1_alpha_3' => 'LBR',
      'iso_3166_1_numeric' => '430',
      'ccTLD'              => '.lr',
      'name_EN'            => 'Liberia',
      'name_DE'            => 'Liberia',
      'name_ES'            => 'Liberia',
      'name_FR'            => 'Libéria',
      'name_IT'            => 'Liberia',
      'name_PT'            => 'Libéria'
      ),
    'LS' => array(
      'iso_3166_1_alpha_3' => 'LSO',
      'iso_3166_1_numeric' => '426',
      'ccTLD'              => '.ls',
      'name_EN'            => 'Lesotho',
      'name_DE'            => 'Lesotho',
      'name_ES'            => 'Lesoto',
      'name_FR'            => 'Lesotho',
      'name_IT'            => 'Lesotho',
      'name_PT'            => 'Lesoto'
      ),
    'LT' => array(
      'iso_3166_1_alpha_3' => 'LTU',
      'iso_3166_1_numeric' => '440',
      'ccTLD'              => '.lt',
      'name_EN'            => 'Lithuania',
      'name_DE'            => 'Litauen',
      'name_ES'            => 'Lituania',
      'name_FR'            => 'Lituanie',
      'name_IT'            => 'Lituania',
      'name_PT'            => 'Lituânia'
      ),
    'LU' => array(
      'iso_3166_1_alpha_3' => 'LUX',
      'iso_3166_1_numeric' => '442',
      'ccTLD'              => '.lu',
      'name_EN'            => 'Luxembourg',
      'name_DE'            => 'Luxemburg',
      'name_ES'            => 'Luxemburgo',
      'name_FR'            => 'Luxembourg (pays)',
      'name_IT'            => 'Lussemburgo',
      'name_PT'            => 'Luxemburgo'
      ),
    'LV' => array(
      'iso_3166_1_alpha_3' => 'LVA',
      'iso_3166_1_numeric' => '428',
      'ccTLD'              => '.lv',
      'name_EN'            => 'Latvia',
      'name_DE'            => 'Lettland',
      'name_ES'            => 'Letonia',
      'name_FR'            => 'Lettonie',
      'name_IT'            => 'Lettonia',
      'name_PT'            => 'Letónia'
      ),
    'LY' => array(
      'iso_3166_1_alpha_3' => 'LBY',
      'iso_3166_1_numeric' => '434',
      'ccTLD'              => '.ly',
      'name_EN'            => 'Libyan Arab Jamahiriya',
      'name_DE'            => 'Libyen',
      'name_ES'            => 'Libia',
      'name_FR'            => 'Libye',
      'name_IT'            => 'Libia',
      'name_PT'            => 'Líbia'
      ),
    'MA' => array(
      'iso_3166_1_alpha_3' => 'MAR',
      'iso_3166_1_numeric' => '504',
      'ccTLD'              => '.ma',
      'name_EN'            => 'Morocco',
      'name_DE'            => 'Marokko',
      'name_ES'            => 'Marruecos',
      'name_FR'            => 'Maroc',
      'name_IT'            => 'Marocco',
      'name_PT'            => 'Marrocos'
      ),
    'MC' => array(
      'iso_3166_1_alpha_3' => 'MCO',
      'iso_3166_1_numeric' => '492',
      'ccTLD'              => '.mc',
      'name_EN'            => 'Monaco',
      'name_DE'            => 'Monaco',
      'name_ES'            => 'Mónaco',
      'name_FR'            => 'Monaco',
      'name_IT'            => 'Monaco',
      'name_PT'            => 'Mónaco'
      ),
    'MD' => array(
      'iso_3166_1_alpha_3' => 'MDA',
      'iso_3166_1_numeric' => '498',
      'ccTLD'              => '.md',
      'name_EN'            => 'Moldova, Republic of',
      'name_DE'            => 'Moldawien',
      'name_ES'            => 'Moldavia',
      'name_FR'            => 'Moldavie',
      'name_IT'            => 'Moldavia',
      'name_PT'            => 'Moldávia'
      ),
    'ME' => array(
      'iso_3166_1_alpha_3' => 'MNE',
      'iso_3166_1_numeric' => '499',
      'ccTLD'              => '.me',
      'name_EN'            => 'Montenegro',
      'name_DE'            => 'Montenegro',
      'name_ES'            => 'Montenegro',
      'name_FR'            => 'Monténégro',
      'name_IT'            => 'Montenegro',
      'name_PT'            => 'Montenegro'
      ),
    'MG' => array(
      'iso_3166_1_alpha_3' => 'MDG',
      'iso_3166_1_numeric' => '450',
      'ccTLD'              => '.mg',
      'name_EN'            => 'Madagascar',
      'name_DE'            => 'Madagaskar',
      'name_ES'            => 'Madagascar',
      'name_FR'            => 'Madagascar',
      'name_IT'            => 'Madagascar',
      'name_PT'            => 'Madagáscar'
      ),
    'MH' => array(
      'iso_3166_1_alpha_3' => 'MHL',
      'iso_3166_1_numeric' => '584',
      'ccTLD'              => '.mh',
      'name_EN'            => 'Marshall Islands',
      'name_DE'            => 'Marshallinseln',
      'name_ES'            => 'Islas Marshall',
      'name_FR'            => 'Marshall (pays)',
      'name_IT'            => 'Isole Marshall',
      'name_PT'            => 'Ilhas Marshall'
      ),
    'MK' => array(
      'iso_3166_1_alpha_3' => 'MKD',
      'iso_3166_1_numeric' => '807',
      'ccTLD'              => '.mk',
      'name_EN'            => 'Macedonia, the former Yugoslav Republic of',
      'name_DE'            => 'Mazedonien',
      'name_ES'            => 'ARY Macedonia',
      'name_FR'            => 'Macédoine (pays)',
      'name_IT'            => 'Macedonia',
      'name_PT'            => 'República da Macedónia'
      ),
    'ML' => array(
      'iso_3166_1_alpha_3' => 'MLI',
      'iso_3166_1_numeric' => '466',
      'ccTLD'              => '.ml',
      'name_EN'            => 'Mali',
      'name_DE'            => 'Mali',
      'name_ES'            => 'Malí',
      'name_FR'            => 'Mali',
      'name_IT'            => 'Mali',
      'name_PT'            => 'Mali'
      ),
    'MM' => array(
      'iso_3166_1_alpha_3' => 'MMR',
      'iso_3166_1_numeric' => '104',
      'ccTLD'              => '.mm',
      'name_EN'            => 'Myanmar',
      'name_DE'            => 'Myanmar (Burma)',
      'name_ES'            => 'Myanmar',
      'name_FR'            => 'Birmanie',
      'name_IT'            => 'Myanmar',
      'name_PT'            => 'Myanmar (antiga \'\'Birmânia\'\')'
      ),
    'MN' => array(
      'iso_3166_1_alpha_3' => 'MNG',
      'iso_3166_1_numeric' => '496',
      'ccTLD'              => '.mn',
      'name_EN'            => 'Mongolia',
      'name_DE'            => 'Mongolei',
      'name_ES'            => 'Mongolia',
      'name_FR'            => 'Mongolie',
      'name_IT'            => 'Mongolia',
      'name_PT'            => 'Mongólia'
      ),
    'MO' => array(
      'iso_3166_1_alpha_3' => 'MAC',
      'iso_3166_1_numeric' => '446',
      'ccTLD'              => '.mo',
      'name_EN'            => 'Macao',
      'name_DE'            => 'Macao',
      'name_ES'            => 'Macao',
      'name_FR'            => 'Macao',
      'name_IT'            => 'Macao',
      'name_PT'            => 'Macau'
      ),
    'MP' => array(
      'iso_3166_1_alpha_3' => 'MNP',
      'iso_3166_1_numeric' => '580',
      'ccTLD'              => '.mp',
      'name_EN'            => 'Northern Mariana Islands',
      'name_DE'            => 'Nördliche Marianen',
      'name_ES'            => 'Islas Marianas del Norte',
      'name_FR'            => 'Îles Mariannes du Nord',
      'name_IT'            => 'Isole Marianne Settentrionali',
      'name_PT'            => 'Marianas Setentrionais'
      ),
    'MQ' => array(
      'iso_3166_1_alpha_3' => 'MTQ',
      'iso_3166_1_numeric' => '474',
      'ccTLD'              => '.mq',
      'name_EN'            => 'Martinique',
      'name_DE'            => 'Martinique',
      'name_ES'            => 'Martinica',
      'name_FR'            => 'Martinique',
      'name_IT'            => 'Martinica',
      'name_PT'            => 'Martinica'
      ),
    'MR' => array(
      'iso_3166_1_alpha_3' => 'MRT',
      'iso_3166_1_numeric' => '478',
      'ccTLD'              => '.mr',
      'name_EN'            => 'Mauritania',
      'name_DE'            => 'Mauretanien',
      'name_ES'            => 'Mauritania',
      'name_FR'            => 'Mauritanie',
      'name_IT'            => 'Mauritania',
      'name_PT'            => 'Mauritânia'
      ),
    'MS' => array(
      'iso_3166_1_alpha_3' => 'MSR',
      'iso_3166_1_numeric' => '500',
      'ccTLD'              => '.ms',
      'name_EN'            => 'Montserrat',
      'name_DE'            => 'Montserrat',
      'name_ES'            => 'Montserrat',
      'name_FR'            => 'Montserrat',
      'name_IT'            => 'Montserrat',
      'name_PT'            => 'Montserrat'
      ),
    'MT' => array(
      'iso_3166_1_alpha_3' => 'MLT',
      'iso_3166_1_numeric' => '470',
      'ccTLD'              => '.mt',
      'name_EN'            => 'Malta',
      'name_DE'            => 'Malta',
      'name_ES'            => 'Malta',
      'name_FR'            => 'Malte',
      'name_IT'            => 'Malta',
      'name_PT'            => 'Malta'
      ),
    'MU' => array(
      'iso_3166_1_alpha_3' => 'MUS',
      'iso_3166_1_numeric' => '480',
      'ccTLD'              => '.mu',
      'name_EN'            => 'Mauritius',
      'name_DE'            => 'Mauritius',
      'name_ES'            => 'Mauricio',
      'name_FR'            => 'Maurice (pays)',
      'name_IT'            => 'Mauritius',
      'name_PT'            => 'Maurícia'
      ),
    'MV' => array(
      'iso_3166_1_alpha_3' => 'MDV',
      'iso_3166_1_numeric' => '462',
      'ccTLD'              => '.mv',
      'name_EN'            => 'Maldives',
      'name_DE'            => 'Malediven',
      'name_ES'            => 'Maldivas',
      'name_FR'            => 'Maldives',
      'name_IT'            => 'Maldive',
      'name_PT'            => 'Maldivas'
      ),
    'MW' => array(
      'iso_3166_1_alpha_3' => 'MWI',
      'iso_3166_1_numeric' => '454',
      'ccTLD'              => '.mw',
      'name_EN'            => 'Malawi',
      'name_DE'            => 'Malawi',
      'name_ES'            => 'Malawi',
      'name_FR'            => 'Malawi',
      'name_IT'            => 'Malawi',
      'name_PT'            => 'Malawi'
      ),
    'MX' => array(
      'iso_3166_1_alpha_3' => 'MEX',
      'iso_3166_1_numeric' => '484',
      'ccTLD'              => '.mx',
      'name_EN'            => 'Mexico',
      'name_DE'            => 'Mexiko',
      'name_ES'            => 'México',
      'name_FR'            => 'Mexique',
      'name_IT'            => 'Messico',
      'name_PT'            => 'México'
      ),
    'MY' => array(
      'iso_3166_1_alpha_3' => 'MYS',
      'iso_3166_1_numeric' => '458',
      'ccTLD'              => '.my',
      'name_EN'            => 'Malaysia',
      'name_DE'            => 'Malaysia',
      'name_ES'            => 'Malasia',
      'name_FR'            => 'Malaisie',
      'name_IT'            => 'Malesia',
      'name_PT'            => 'Malásia'
      ),
    'MZ' => array(
      'iso_3166_1_alpha_3' => 'MOZ',
      'iso_3166_1_numeric' => '508',
      'ccTLD'              => '.mz',
      'name_EN'            => 'Mozambique',
      'name_DE'            => 'Mosambik',
      'name_ES'            => 'Mozambique',
      'name_FR'            => 'Mozambique',
      'name_IT'            => 'Mozambico',
      'name_PT'            => 'Moçambique'
      ),
    'NA' => array(
      'iso_3166_1_alpha_3' => 'NAM',
      'iso_3166_1_numeric' => '516',
      'ccTLD'              => '.na',
      'name_EN'            => 'Namibia',
      'name_DE'            => 'Namibia',
      'name_ES'            => 'Namibia',
      'name_FR'            => 'Namibie',
      'name_IT'            => 'Namibia',
      'name_PT'            => 'Namíbia'
      ),
    'NC' => array(
      'iso_3166_1_alpha_3' => 'NCL',
      'iso_3166_1_numeric' => '540',
      'ccTLD'              => '.nc',
      'name_EN'            => 'New Caledonia',
      'name_DE'            => 'Neukaledonien',
      'name_ES'            => 'Nueva Caledonia',
      'name_FR'            => 'Nouvelle-Calédonie',
      'name_IT'            => 'Nuova Caledonia',
      'name_PT'            => 'Nova Caledónia'
      ),
    'NE' => array(
      'iso_3166_1_alpha_3' => 'NER',
      'iso_3166_1_numeric' => '562',
      'ccTLD'              => '.ne',
      'name_EN'            => 'Niger',
      'name_DE'            => 'Niger',
      'name_ES'            => 'Níger',
      'name_FR'            => 'Niger',
      'name_IT'            => 'Niger',
      'name_PT'            => 'Níger'
      ),
    'NF' => array(
      'iso_3166_1_alpha_3' => 'NFK',
      'iso_3166_1_numeric' => '574',
      'ccTLD'              => '.nf',
      'name_EN'            => 'Norfolk Island',
      'name_DE'            => 'Norfolkinsel',
      'name_ES'            => 'Norfolk',
      'name_FR'            => 'Norfolk',
      'name_IT'            => 'Isola Norfolk',
      'name_PT'            => 'Ilha Norfolk'
      ),
    'NG' => array(
      'iso_3166_1_alpha_3' => 'NGA',
      'iso_3166_1_numeric' => '566',
      'ccTLD'              => '.ng',
      'name_EN'            => 'Nigeria',
      'name_DE'            => 'Nigeria',
      'name_ES'            => 'Nigeria',
      'name_FR'            => 'Nigeria',
      'name_IT'            => 'Nigeria',
      'name_PT'            => 'Nigéria'
      ),
    'NI' => array(
      'iso_3166_1_alpha_3' => 'NIC',
      'iso_3166_1_numeric' => '558',
      'ccTLD'              => '.ni',
      'name_EN'            => 'Nicaragua',
      'name_DE'            => 'Nicaragua',
      'name_ES'            => 'Nicaragua',
      'name_FR'            => 'Nicaragua',
      'name_IT'            => 'Nicaragua',
      'name_PT'            => 'Nicarágua'
      ),
    'NL' => array(
      'iso_3166_1_alpha_3' => 'NLD',
      'iso_3166_1_numeric' => '528',
      'ccTLD'              => '.nl',
      'name_EN'            => 'Netherlands',
      'name_DE'            => 'Niederlande',
      'name_ES'            => 'Países Bajos',
      'name_FR'            => 'Pays-Bas',
      'name_IT'            => 'Paesi Bassi',
      'name_PT'            => 'Países Baixos (\'\'Holanda\'\')'
      ),
    'NO' => array(
      'iso_3166_1_alpha_3' => 'NOR',
      'iso_3166_1_numeric' => '578',
      'ccTLD'              => '.no',
      'name_EN'            => 'Norway',
      'name_DE'            => 'Norwegen',
      'name_ES'            => 'Noruega',
      'name_FR'            => 'Norvège',
      'name_IT'            => 'Norvegia',
      'name_PT'            => 'Noruega'
      ),
    'NP' => array(
      'iso_3166_1_alpha_3' => 'NPL',
      'iso_3166_1_numeric' => '524',
      'ccTLD'              => '.np',
      'name_EN'            => 'Nepal',
      'name_DE'            => 'Nepal',
      'name_ES'            => 'Nepal',
      'name_FR'            => 'Népal',
      'name_IT'            => 'Nepal',
      'name_PT'            => 'Nepal'
      ),
    'NR' => array(
      'iso_3166_1_alpha_3' => 'NRU',
      'iso_3166_1_numeric' => '520',
      'ccTLD'              => '.nr',
      'name_EN'            => 'Nauru',
      'name_DE'            => 'Nauru',
      'name_ES'            => 'Nauru',
      'name_FR'            => 'Nauru',
      'name_IT'            => 'Nauru',
      'name_PT'            => 'Nauru'
      ),
    'NU' => array(
      'iso_3166_1_alpha_3' => 'NIU',
      'iso_3166_1_numeric' => '570',
      'ccTLD'              => '.nu',
      'name_EN'            => 'Niue',
      'name_DE'            => 'Niue',
      'name_ES'            => 'Niue',
      'name_FR'            => 'Niué',
      'name_IT'            => 'Niue',
      'name_PT'            => 'Niue'
      ),
    'NZ' => array(
      'iso_3166_1_alpha_3' => 'NZL',
      'iso_3166_1_numeric' => '554',
      'ccTLD'              => '.nz',
      'name_EN'            => 'New Zealand',
      'name_DE'            => 'Neuseeland',
      'name_ES'            => 'Nueva Zelanda',
      'name_FR'            => 'Nouvelle-Zélande',
      'name_IT'            => 'Nuova Zelanda',
      'name_PT'            => 'Nova Zelândia (\'\'Aotearoa\'\')'
      ),
    'OM' => array(
      'iso_3166_1_alpha_3' => 'OMN',
      'iso_3166_1_numeric' => '512',
      'ccTLD'              => '.om',
      'name_EN'            => 'Oman',
      'name_DE'            => 'Oman',
      'name_ES'            => 'Omán',
      'name_FR'            => 'Oman',
      'name_IT'            => 'Oman',
      'name_PT'            => 'Oman'
      ),
    'PA' => array(
      'iso_3166_1_alpha_3' => 'PAN',
      'iso_3166_1_numeric' => '591',
      'ccTLD'              => '.pa',
      'name_EN'            => 'Panama',
      'name_DE'            => 'Panama',
      'name_ES'            => 'Panamá',
      'name_FR'            => 'Panamá',
      'name_IT'            => 'Panamá',
      'name_PT'            => 'Panamá'
      ),
    'PE' => array(
      'iso_3166_1_alpha_3' => 'PER',
      'iso_3166_1_numeric' => '604',
      'ccTLD'              => '.pe',
      'name_EN'            => 'Peru',
      'name_DE'            => 'Peru',
      'name_ES'            => 'Perú',
      'name_FR'            => 'Pérou',
      'name_IT'            => 'Perù',
      'name_PT'            => 'Peru'
      ),
    'PF' => array(
      'iso_3166_1_alpha_3' => 'PYF',
      'iso_3166_1_numeric' => '258',
      'ccTLD'              => '.pf',
      'name_EN'            => 'French Polynesia',
      'name_DE'            => 'Französisch-Polynesien',
      'name_ES'            => 'Polinesia Francesa',
      'name_FR'            => 'Polynésie française',
      'name_IT'            => 'Polinesia Francese',
      'name_PT'            => 'Polinésia Francesa'
      ),
    'PG' => array(
      'iso_3166_1_alpha_3' => 'PNG',
      'iso_3166_1_numeric' => '598',
      'ccTLD'              => '.pg',
      'name_EN'            => 'Papua New Guinea',
      'name_DE'            => 'Papua-Neuguinea',
      'name_ES'            => 'Papúa Nueva Guinea',
      'name_FR'            => 'Papouasie-Nouvelle-Guinée',
      'name_IT'            => 'Papua Nuova Guinea',
      'name_PT'            => 'Papua-Nova Guiné'
      ),
    'PH' => array(
      'iso_3166_1_alpha_3' => 'PHL',
      'iso_3166_1_numeric' => '608',
      'ccTLD'              => '.ph',
      'name_EN'            => 'Philippines',
      'name_DE'            => 'Philippinen',
      'name_ES'            => 'Filipinas',
      'name_FR'            => 'Philippines',
      'name_IT'            => 'Filippine',
      'name_PT'            => 'Filipinas'
      ),
    'PK' => array(
      'iso_3166_1_alpha_3' => 'PAK',
      'iso_3166_1_numeric' => '586',
      'ccTLD'              => '.pk',
      'name_EN'            => 'Pakistan',
      'name_DE'            => 'Pakistan',
      'name_ES'            => 'Pakistán',
      'name_FR'            => 'Pakistan',
      'name_IT'            => 'Pakistan',
      'name_PT'            => 'Paquistão'
      ),
    'PL' => array(
      'iso_3166_1_alpha_3' => 'POL',
      'iso_3166_1_numeric' => '616',
      'ccTLD'              => '.pl',
      'name_EN'            => 'Poland',
      'name_DE'            => 'Polen',
      'name_ES'            => 'Polonia',
      'name_FR'            => 'Pologne',
      'name_IT'            => 'Polonia',
      'name_PT'            => 'Polónia'
      ),
    'PM' => array(
      'iso_3166_1_alpha_3' => 'SPM',
      'iso_3166_1_numeric' => '666',
      'ccTLD'              => '.pm',
      'name_EN'            => 'Saint Pierre and Miquelon',
      'name_DE'            => 'Saint-Pierre und Miquelon',
      'name_ES'            => 'San Pedro y Miquelón',
      'name_FR'            => 'Saint-Pierre-et-Miquelon',
      'name_IT'            => 'Saint Pierre e Miquelon',
      'name_PT'            => 'Saint Pierre et Miquelon'
      ),
    'PN' => array(
      'iso_3166_1_alpha_3' => 'PCN',
      'iso_3166_1_numeric' => '612',
      'ccTLD'              => '.pn',
      'name_EN'            => 'Pitcairn',
      'name_DE'            => 'Pitcairninseln',
      'name_ES'            => 'Islas Pitcairn',
      'name_FR'            => 'Pitcairn',
      'name_IT'            => 'Pitcairn',
      'name_PT'            => 'Pitcairn'
      ),
    'PR' => array(
      'iso_3166_1_alpha_3' => 'PRI',
      'iso_3166_1_numeric' => '630',
      'ccTLD'              => '.pr',
      'name_EN'            => 'Puerto Rico',
      'name_DE'            => 'Puerto Rico',
      'name_ES'            => 'Puerto Rico',
      'name_FR'            => 'Porto Rico',
      'name_IT'            => 'Porto Rico',
      'name_PT'            => 'Porto Rico'
      ),
    'PS' => array(
      'iso_3166_1_alpha_3' => 'PSE',
      'iso_3166_1_numeric' => '275',
      'ccTLD'              => '.ps',
      'name_EN'            => 'Palestinian Territory, Occupied',
      'name_DE'            => 'Palästinensische Autonomiegebiete',
      'name_ES'            => 'Palestina (ANP)',
      'name_FR'            => 'Palestine',
      'name_IT'            => 'Territori Palestinesi Occupati',
      'name_PT'            => 'Palestina'
      ),
    'PT' => array(
      'iso_3166_1_alpha_3' => 'PRT',
      'iso_3166_1_numeric' => '620',
      'ccTLD'              => '.pt',
      'name_EN'            => 'Portugal',
      'name_DE'            => 'Portugal',
      'name_ES'            => 'Portugal',
      'name_FR'            => 'Portugal',
      'name_IT'            => 'Portogallo',
      'name_PT'            => 'Portugal'
      ),
    'PW' => array(
      'iso_3166_1_alpha_3' => 'PLW',
      'iso_3166_1_numeric' => '585',
      'ccTLD'              => '.pw',
      'name_EN'            => 'Palau',
      'name_DE'            => 'Palau',
      'name_ES'            => 'Palaos',
      'name_FR'            => 'Palaos',
      'name_IT'            => 'Palau',
      'name_PT'            => 'Palau'
      ),
    'PY' => array(
      'iso_3166_1_alpha_3' => 'PRY',
      'iso_3166_1_numeric' => '600',
      'ccTLD'              => '.py',
      'name_EN'            => 'Paraguay',
      'name_DE'            => 'Paraguay',
      'name_ES'            => 'Paraguay',
      'name_FR'            => 'Paraguay',
      'name_IT'            => 'Paraguay',
      'name_PT'            => 'Paraguai'
      ),
    'QA' => array(
      'iso_3166_1_alpha_3' => 'QAT',
      'iso_3166_1_numeric' => '634',
      'ccTLD'              => '.qa',
      'name_EN'            => 'Qatar',
      'name_DE'            => 'Katar',
      'name_ES'            => 'Qatar',
      'name_FR'            => 'Qatar',
      'name_IT'            => 'Qatar',
      'name_PT'            => 'Qatar'
      ),
    'RE' => array(
      'iso_3166_1_alpha_3' => 'REU',
      'iso_3166_1_numeric' => '638',
      'ccTLD'              => '.re',
      'name_EN'            => 'Réunion',
      'name_DE'            => 'Reunion',
      'name_ES'            => 'Reunión',
      'name_FR'            => 'La Réunion',
      'name_IT'            => 'Reunion',
      'name_PT'            => 'Reunião'
      ),
    'RO' => array(
      'iso_3166_1_alpha_3' => 'ROU',
      'iso_3166_1_numeric' => '642',
      'ccTLD'              => '.ro',
      'name_EN'            => 'Romania',
      'name_DE'            => 'Rumänien',
      'name_ES'            => 'Rumania',
      'name_FR'            => 'Roumanie',
      'name_IT'            => 'Romania',
      'name_PT'            => 'Roménia'
      ),
    'RS' => array(
      'iso_3166_1_alpha_3' => 'SRB',
      'iso_3166_1_numeric' => '688',
      'ccTLD'              => '.rs',
      'name_EN'            => 'Serbia',
      'name_DE'            => 'Serbien',
      'name_ES'            => 'Serbia',
      'name_FR'            => 'Serbie',
      'name_IT'            => 'Serbia[1]',
      'name_PT'            => 'Sérvia'
      ),
    'RU' => array(
      'iso_3166_1_alpha_3' => 'RUS',
      'iso_3166_1_numeric' => '643',
      'ccTLD'              => '.ru',
      'name_EN'            => 'Russian Federation',
      'name_DE'            => 'Russische Föderation',
      'name_ES'            => 'Federación Rusa',
      'name_FR'            => 'Fédération de Russie',
      'name_IT'            => 'Federazione Russa',
      'name_PT'            => 'Federação da Rússia'
      ),
    'RW' => array(
      'iso_3166_1_alpha_3' => 'RWA',
      'iso_3166_1_numeric' => '646',
      'ccTLD'              => '.rw',
      'name_EN'            => 'Rwanda',
      'name_DE'            => 'Ruanda',
      'name_ES'            => 'Ruanda',
      'name_FR'            => 'Rwanda',
      'name_IT'            => 'Ruanda',
      'name_PT'            => 'Ruanda'
      ),
    'SA' => array(
      'iso_3166_1_alpha_3' => 'SAU',
      'iso_3166_1_numeric' => '682',
      'ccTLD'              => '.sa',
      'name_EN'            => 'Saudi Arabia',
      'name_DE'            => 'Saudi-Arabien',
      'name_ES'            => 'Arabia Saudita',
      'name_FR'            => 'Arabie saoudite',
      'name_IT'            => 'Arabia Saudita',
      'name_PT'            => 'Arábia Saudita'
      ),
    'SB' => array(
      'iso_3166_1_alpha_3' => 'SLB',
      'iso_3166_1_numeric' => '90',
      'ccTLD'              => '.sb',
      'name_EN'            => 'Solomon Islands',
      'name_DE'            => 'Salomonen',
      'name_ES'            => 'Islas Salomón',
      'name_FR'            => 'Îles Salomon',
      'name_IT'            => 'Isole Solomon',
      'name_PT'            => 'Ilhas Salomão'
      ),
    'SC' => array(
      'iso_3166_1_alpha_3' => 'SYC',
      'iso_3166_1_numeric' => '690',
      'ccTLD'              => '.sc',
      'name_EN'            => 'Seychelles',
      'name_DE'            => 'Seychellen',
      'name_ES'            => 'Seychelles',
      'name_FR'            => 'Seychelles',
      'name_IT'            => 'Seychelles',
      'name_PT'            => 'Seychelles'
      ),
    'SD' => array(
      'iso_3166_1_alpha_3' => 'SDN',
      'iso_3166_1_numeric' => '729',
      'ccTLD'              => '.sd',
      'name_EN'            => 'Sudan',
      'name_DE'            => 'Sudan',
      'name_ES'            => 'Sudán',
      'name_FR'            => 'Soudan',
      'name_IT'            => 'Sudan',
      'name_PT'            => 'Sudão'
      ),
    'SE' => array(
      'iso_3166_1_alpha_3' => 'SWE',
      'iso_3166_1_numeric' => '752',
      'ccTLD'              => '.se',
      'name_EN'            => 'Sweden',
      'name_DE'            => 'Schweden',
      'name_ES'            => 'Suecia',
      'name_FR'            => 'Suède',
      'name_IT'            => 'Svezia',
      'name_PT'            => 'Suécia'
      ),
    'SG' => array(
      'iso_3166_1_alpha_3' => 'SGP',
      'iso_3166_1_numeric' => '702',
      'ccTLD'              => '.sg',
      'name_EN'            => 'Singapore',
      'name_DE'            => 'Singapur',
      'name_ES'            => 'Singapur',
      'name_FR'            => 'Singapour',
      'name_IT'            => 'Singapore',
      'name_PT'            => 'Singapura'
      ),
    'SH' => array(
      'iso_3166_1_alpha_3' => 'SHN',
      'iso_3166_1_numeric' => '654',
      'ccTLD'              => '.sh',
      'name_EN'            => 'Saint Helena',
      'name_DE'            => 'St. Helena',
      'name_ES'            => 'Santa Helena',
      'name_FR'            => 'Sainte-Hélène (territoire)',
      'name_IT'            => 'Sant\'Elena',
      'name_PT'            => 'Santa Helena'
      ),
    'SI' => array(
      'iso_3166_1_alpha_3' => 'SVN',
      'iso_3166_1_numeric' => '705',
      'ccTLD'              => '.si',
      'name_EN'            => 'Slovenia',
      'name_DE'            => 'Slowenien',
      'name_ES'            => 'Eslovenia',
      'name_FR'            => 'Slovénie',
      'name_IT'            => 'Slovenia',
      'name_PT'            => 'Eslovénia'
      ),
    'SJ' => array(
      'iso_3166_1_alpha_3' => 'SJM',
      'iso_3166_1_numeric' => '744',
      'ccTLD'              => '.sj',
      'name_EN'            => 'Svalbard and Jan Mayen',
      'name_DE'            => 'Svalbard und Jan Mayen',
      'name_ES'            => 'Svalbard y Jan Mayen',
      'name_FR'            => 'Svalbard et île Jan Mayen',
      'name_IT'            => 'Svalbard e Jan Mayen',
      'name_PT'            => 'Svalbard e Jan Mayen'
      ),
    'SK' => array(
      'iso_3166_1_alpha_3' => 'SVK',
      'iso_3166_1_numeric' => '703',
      'ccTLD'              => '.sk',
      'name_EN'            => 'Slovakia',
      'name_DE'            => 'Slowakei',
      'name_ES'            => 'Eslovaquia',
      'name_FR'            => 'Slovaquie',
      'name_IT'            => 'Slovacchia',
      'name_PT'            => 'Eslováquia'
      ),
    'SL' => array(
      'iso_3166_1_alpha_3' => 'SLE',
      'iso_3166_1_numeric' => '694',
      'ccTLD'              => '.sl',
      'name_EN'            => 'Sierra Leone',
      'name_DE'            => 'Sierra Leone',
      'name_ES'            => 'Sierra Leona',
      'name_FR'            => 'Sierra Leone',
      'name_IT'            => 'Sierra Leone',
      'name_PT'            => 'Serra Leoa'
      ),
    'SM' => array(
      'iso_3166_1_alpha_3' => 'SMR',
      'iso_3166_1_numeric' => '674',
      'ccTLD'              => '.sm',
      'name_EN'            => 'San Marino',
      'name_DE'            => 'San Marino',
      'name_ES'            => 'San Marino',
      'name_FR'            => 'Saint-Marin',
      'name_IT'            => 'San Marino',
      'name_PT'            => 'San Marino'
      ),
    'SN' => array(
      'iso_3166_1_alpha_3' => 'SEN',
      'iso_3166_1_numeric' => '686',
      'ccTLD'              => '.sn',
      'name_EN'            => 'Senegal',
      'name_DE'            => 'Senegal',
      'name_ES'            => 'Senegal',
      'name_FR'            => 'Sénégal',
      'name_IT'            => 'Senegal',
      'name_PT'            => 'Senegal'
      ),
    'SO' => array(
      'iso_3166_1_alpha_3' => 'SOM',
      'iso_3166_1_numeric' => '706',
      'ccTLD'              => '.so',
      'name_EN'            => 'Somalia',
      'name_DE'            => 'Somalia',
      'name_ES'            => 'Somalia',
      'name_FR'            => 'Somalie',
      'name_IT'            => 'Somalia',
      'name_PT'            => 'Somália'
      ),
    'SR' => array(
      'iso_3166_1_alpha_3' => 'SUR',
      'iso_3166_1_numeric' => '740',
      'ccTLD'              => '.sr',
      'name_EN'            => 'Suriname',
      'name_DE'            => 'Suriname',
      'name_ES'            => 'Surinam',
      'name_FR'            => 'Suriname',
      'name_IT'            => 'Suriname',
      'name_PT'            => 'Suriname'
      ),
    'ST' => array(
      'iso_3166_1_alpha_3' => 'STP',
      'iso_3166_1_numeric' => '678',
      'ccTLD'              => '.st',
      'name_EN'            => 'Sao Tome and Principe',
      'name_DE'            => 'São Tomé und Príncipe',
      'name_ES'            => 'Santo Tomé y Príncipe',
      'name_FR'            => 'São Tomé-et-Principe',
      'name_IT'            => 'Sao Tome e Principe',
      'name_PT'            => 'São Tomé e Príncipe'
      ),
    'SV' => array(
      'iso_3166_1_alpha_3' => 'SLV',
      'iso_3166_1_numeric' => '222',
      'ccTLD'              => '.sv',
      'name_EN'            => 'El Salvador',
      'name_DE'            => 'El Salvador',
      'name_ES'            => 'El Salvador',
      'name_FR'            => 'Salvador',
      'name_IT'            => 'El Salvador',
      'name_PT'            => 'El Salvador'
      ),
    'SY' => array(
      'iso_3166_1_alpha_3' => 'SYR',
      'iso_3166_1_numeric' => '760',
      'ccTLD'              => '.sy',
      'name_EN'            => 'Syrian Arab Republic',
      'name_DE'            => 'Syrien',
      'name_ES'            => 'Siria',
      'name_FR'            => 'Syrie',
      'name_IT'            => 'Siria',
      'name_PT'            => 'Síria'
      ),
    'SZ' => array(
      'iso_3166_1_alpha_3' => 'SWZ',
      'iso_3166_1_numeric' => '748',
      'ccTLD'              => '.sz',
      'name_EN'            => 'Swaziland',
      'name_DE'            => 'Swasiland',
      'name_ES'            => 'Suazilandia',
      'name_FR'            => 'Swaziland',
      'name_IT'            => 'Swaziland',
      'name_PT'            => 'Suazilândia'
      ),
    'TC' => array(
      'iso_3166_1_alpha_3' => 'TCA',
      'iso_3166_1_numeric' => '796',
      'ccTLD'              => '.tc',
      'name_EN'            => 'Turks and Caicos Islands',
      'name_DE'            => 'Turks- und Caicosinseln',
      'name_ES'            => 'Islas Turcas y Caicos',
      'name_FR'            => 'Îles Turques et Caïques',
      'name_IT'            => 'Isole Turks e Caicos',
      'name_PT'            => 'Turks e Caicos'
      ),
    'TD' => array(
      'iso_3166_1_alpha_3' => 'TCD',
      'iso_3166_1_numeric' => '148',
      'ccTLD'              => '.td',
      'name_EN'            => 'Chad',
      'name_DE'            => 'Tschad',
      'name_ES'            => 'Chad',
      'name_FR'            => 'Tchad',
      'name_IT'            => 'Ciad',
      'name_PT'            => 'Chade'
      ),
    'TF' => array(
      'iso_3166_1_alpha_3' => 'ATF',
      'iso_3166_1_numeric' => '260',
      'ccTLD'              => '.tf',
      'name_EN'            => 'French Southern Territories',
      'name_DE'            => 'Französische Süd- und Antarktisgebiete',
      'name_ES'            => 'Territorios Australes Franceses',
      'name_FR'            => 'Terres australes et antarctiques françaises',
      'name_IT'            => 'Territori Francesi del Sud',
      'name_PT'            => 'Terras Austrais e Antárticas Francesas (\'\'TAAF\'\')'
      ),
    'TG' => array(
      'iso_3166_1_alpha_3' => 'TGO',
      'iso_3166_1_numeric' => '768',
      'ccTLD'              => '.tg',
      'name_EN'            => 'Togo',
      'name_DE'            => 'Togo',
      'name_ES'            => 'Togo',
      'name_FR'            => 'Togo',
      'name_IT'            => 'Togo',
      'name_PT'            => 'Togo'
      ),
    'TH' => array(
      'iso_3166_1_alpha_3' => 'THA',
      'iso_3166_1_numeric' => '764',
      'ccTLD'              => '.th',
      'name_EN'            => 'Thailand',
      'name_DE'            => 'Thailand',
      'name_ES'            => 'Tailandia',
      'name_FR'            => 'Thaïlande',
      'name_IT'            => 'Thailandia',
      'name_PT'            => 'Tailândia'
      ),
    'TJ' => array(
      'iso_3166_1_alpha_3' => 'TJK',
      'iso_3166_1_numeric' => '762',
      'ccTLD'              => '.tj',
      'name_EN'            => 'Tajikistan',
      'name_DE'            => 'Tadschikistan',
      'name_ES'            => 'Tayikistán',
      'name_FR'            => 'Tadjikistan',
      'name_IT'            => 'Tagikistan',
      'name_PT'            => 'Tajiquistão'
      ),
    'TK' => array(
      'iso_3166_1_alpha_3' => 'TKL',
      'iso_3166_1_numeric' => '772',
      'ccTLD'              => '.tk',
      'name_EN'            => 'Tokelau',
      'name_DE'            => 'Tokelau',
      'name_ES'            => 'Tokelau',
      'name_FR'            => 'Tokelau',
      'name_IT'            => 'Tokelau',
      'name_PT'            => 'Toquelau'
      ),
    'TL' => array(
      'iso_3166_1_alpha_3' => 'TLS',
      'iso_3166_1_numeric' => '626',
      'ccTLD'              => '.tl',
      'name_EN'            => 'Timor-Leste',
      'name_DE'            => 'Osttimor',
      'name_ES'            => 'Timor Oriental',
      'name_FR'            => 'Timor oriental',
      'name_IT'            => 'Timor Est',
      'name_PT'            => 'Timor-Leste'
      ),
    'TM' => array(
      'iso_3166_1_alpha_3' => 'TKM',
      'iso_3166_1_numeric' => '795',
      'ccTLD'              => '.tm',
      'name_EN'            => 'Turkmenistan',
      'name_DE'            => 'Turkmenistan',
      'name_ES'            => 'Turkmenistán',
      'name_FR'            => 'Turkménistan',
      'name_IT'            => 'Turkmenistan',
      'name_PT'            => 'Turquemenistão'
      ),
    'TN' => array(
      'iso_3166_1_alpha_3' => 'TUN',
      'iso_3166_1_numeric' => '788',
      'ccTLD'              => '.tn',
      'name_EN'            => 'Tunisia',
      'name_DE'            => 'Tunesien',
      'name_ES'            => 'Túnez',
      'name_FR'            => 'Tunisie',
      'name_IT'            => 'Tunisia',
      'name_PT'            => 'Tunísia'
      ),
    'TO' => array(
      'iso_3166_1_alpha_3' => 'TON',
      'iso_3166_1_numeric' => '776',
      'ccTLD'              => '.to',
      'name_EN'            => 'Tonga',
      'name_DE'            => 'Tonga',
      'name_ES'            => 'Tonga',
      'name_FR'            => 'Tonga',
      'name_IT'            => 'Tonga',
      'name_PT'            => 'Tonga'
      ),
    'TR' => array(
      'iso_3166_1_alpha_3' => 'TUR',
      'iso_3166_1_numeric' => '792',
      'ccTLD'              => '.tr',
      'name_EN'            => 'Turkey',
      'name_DE'            => 'Türkei',
      'name_ES'            => 'Turquía',
      'name_FR'            => 'Turquie',
      'name_IT'            => 'Turchia',
      'name_PT'            => 'Turquia'
      ),
    'TT' => array(
      'iso_3166_1_alpha_3' => 'TTO',
      'iso_3166_1_numeric' => '780',
      'ccTLD'              => '.tt',
      'name_EN'            => 'Trinidad and Tobago',
      'name_DE'            => 'Trinidad und Tobago',
      'name_ES'            => 'Trinidad y Tobago',
      'name_FR'            => 'Trinité-et-Tobago',
      'name_IT'            => 'Trinidad e Tobago',
      'name_PT'            => 'Trindade e Tobago'
      ),
    'TV' => array(
      'iso_3166_1_alpha_3' => 'TUV',
      'iso_3166_1_numeric' => '798',
      'ccTLD'              => '.tv',
      'name_EN'            => 'Tuvalu',
      'name_DE'            => 'Tuvalu',
      'name_ES'            => 'Tuvalu',
      'name_FR'            => 'Tuvalu',
      'name_IT'            => 'Tuvalu',
      'name_PT'            => 'Tuvalu'
      ),
    'TW' => array(
      'iso_3166_1_alpha_3' => 'TWN',
      'iso_3166_1_numeric' => '158',
      'ccTLD'              => '.tw',
      'name_EN'            => 'Taiwan, Province of China',
      'name_DE'            => 'Republik China (Taiwan)',
      'name_ES'            => 'Taiwán',
      'name_FR'            => 'Taïwan / (République de Chine)',
      'name_IT'            => 'Taiwan',
      'name_PT'            => 'Taiwan'
      ),
    'TZ' => array(
      'iso_3166_1_alpha_3' => 'TZA',
      'iso_3166_1_numeric' => '834',
      'ccTLD'              => '.tz',
      'name_EN'            => 'Tanzania, United Republic of',
      'name_DE'            => 'Tansania',
      'name_ES'            => 'Tanzania',
      'name_FR'            => 'Tanzanie',
      'name_IT'            => 'Tanzania',
      'name_PT'            => 'Tanzânia'
      ),
    'UA' => array(
      'iso_3166_1_alpha_3' => 'UKR',
      'iso_3166_1_numeric' => '804',
      'ccTLD'              => '.ua',
      'name_EN'            => 'Ukraine',
      'name_DE'            => 'Ukraine',
      'name_ES'            => 'Ucrania',
      'name_FR'            => 'Ukraine',
      'name_IT'            => 'Ucraina',
      'name_PT'            => 'Ucrânia'
      ),
    'UG' => array(
      'iso_3166_1_alpha_3' => 'UGA',
      'iso_3166_1_numeric' => '800',
      'ccTLD'              => '.ug',
      'name_EN'            => 'Uganda',
      'name_DE'            => 'Uganda',
      'name_ES'            => 'Uganda',
      'name_FR'            => 'Ouganda',
      'name_IT'            => 'Uganda',
      'name_PT'            => 'Uganda'
      ),
    'UM' => array(
      'iso_3166_1_alpha_3' => 'UMI',
      'iso_3166_1_numeric' => '581',
      'ccTLD'              => '.um',
      'name_EN'            => 'United States Minor Outlying Islands',
      'name_DE'            => 'United States Minor Outlying Islands',
      'name_ES'            => 'Islas ultramarinas de Estados Unidos',
      'name_FR'            => 'Îles mineures éloignées des États-Unis',
      'name_IT'            => 'Isole Minori degli Stati Uniti d\'America',
      'name_PT'            => 'Ilhas Menores Distantes dos Estados Unidos'
      ),
    'US' => array(
      'iso_3166_1_alpha_3' => 'USA',
      'iso_3166_1_numeric' => '840',
      'ccTLD'              => '.us',
      'name_EN'            => 'United States',
      'name_DE'            => 'Vereinigte Staaten von Amerika',
      'name_ES'            => 'Estados Unidos',
      'name_FR'            => 'États-Unis',
      'name_IT'            => 'Stati Uniti d\'America',
      'name_PT'            => 'Estados Unidos da América'
      ),
    'UY' => array(
      'iso_3166_1_alpha_3' => 'URY',
      'iso_3166_1_numeric' => '858',
      'ccTLD'              => '.uy',
      'name_EN'            => 'Uruguay',
      'name_DE'            => 'Uruguay',
      'name_ES'            => 'Uruguay',
      'name_FR'            => 'Uruguay',
      'name_IT'            => 'Uruguay',
      'name_PT'            => 'Uruguai'
      ),
    'UZ' => array(
      'iso_3166_1_alpha_3' => 'UZB',
      'iso_3166_1_numeric' => '860',
      'ccTLD'              => '.uz',
      'name_EN'            => 'Uzbekistan',
      'name_DE'            => 'Usbekistan',
      'name_ES'            => 'Uzbekistán',
      'name_FR'            => 'Ouzbékistan',
      'name_IT'            => 'Uzbekistan',
      'name_PT'            => 'Usbequistão'
      ),
    'VA' => array(
      'iso_3166_1_alpha_3' => 'VAT',
      'iso_3166_1_numeric' => '336',
      'ccTLD'              => '.va',
      'name_EN'            => 'Holy See (Vatican City State)',
      'name_DE'            => 'Vatikanstadt',
      'name_ES'            => 'Ciudad del Vaticano',
      'name_FR'            => 'Vatican / (Saint-Siège)',
      'name_IT'            => 'Città del Vaticano',
      'name_PT'            => 'Vaticano'
      ),
    'VC' => array(
      'iso_3166_1_alpha_3' => 'VCT',
      'iso_3166_1_numeric' => '670',
      'ccTLD'              => '.vc',
      'name_EN'            => 'Saint Vincent and the Grenadines',
      'name_DE'            => 'St. Vincent und die Grenadinen',
      'name_ES'            => 'San Vicente y las Granadinas',
      'name_FR'            => 'Saint-Vincent-et-les Grenadines',
      'name_IT'            => 'Saint Vincent e Grenadine',
      'name_PT'            => 'São Vicente e Granadinas'
      ),
    'VE' => array(
      'iso_3166_1_alpha_3' => 'VEN',
      'iso_3166_1_numeric' => '862',
      'ccTLD'              => '.ve',
      'name_EN'            => 'Venezuela',
      'name_DE'            => 'Venezuela',
      'name_ES'            => 'Venezuela',
      'name_FR'            => 'Venezuela',
      'name_IT'            => 'Venezuela',
      'name_PT'            => 'Venezuela'
      ),
    'VG' => array(
      'iso_3166_1_alpha_3' => 'VGB',
      'iso_3166_1_numeric' => '92',
      'ccTLD'              => '.vg',
      'name_EN'            => 'Virgin Islands, British',
      'name_DE'            => 'Britische Jungferninseln',
      'name_ES'            => 'Islas Vírgenes Británicas',
      'name_FR'            => 'Îles Vierges britanniques',
      'name_IT'            => 'Territori Britannici dell\'Oceano Indiano',
      'name_PT'            => 'Ilhas Virgens Britânicas'
      ),
    'VI' => array(
      'iso_3166_1_alpha_3' => 'VIR',
      'iso_3166_1_numeric' => '850',
      'ccTLD'              => '.vi',
      'name_EN'            => 'Virgin Islands, U.S.',
      'name_DE'            => 'Amerikanische Jungferninseln',
      'name_ES'            => 'Islas Vírgenes Estadounidenses',
      'name_FR'            => 'Îles Vierges américaines',
      'name_IT'            => 'Isole Vergini Americane',
      'name_PT'            => 'Ilhas Virgens Americanas'
      ),
    'VN' => array(
      'iso_3166_1_alpha_3' => 'VNM',
      'iso_3166_1_numeric' => '704',
      'ccTLD'              => '.vn',
      'name_EN'            => 'Viet Nam',
      'name_DE'            => 'Vietnam',
      'name_ES'            => 'Vietnam',
      'name_FR'            => 'Viêt Nam',
      'name_IT'            => 'Vietnam',
      'name_PT'            => 'Vietname'
      ),
    'VU' => array(
      'iso_3166_1_alpha_3' => 'VUT',
      'iso_3166_1_numeric' => '548',
      'ccTLD'              => '.vu',
      'name_EN'            => 'Vanuatu',
      'name_DE'            => 'Vanuatu',
      'name_ES'            => 'Vanuatu',
      'name_FR'            => 'Vanuatu',
      'name_IT'            => 'Vanuatu',
      'name_PT'            => 'Vanuatu'
      ),
    'WF' => array(
      'iso_3166_1_alpha_3' => 'WLF',
      'iso_3166_1_numeric' => '876',
      'ccTLD'              => '.wf',
      'name_EN'            => 'Wallis and Futuna',
      'name_DE'            => 'Wallis und Futuna',
      'name_ES'            => 'Wallis y Futuna',
      'name_FR'            => 'Wallis-et-Futuna',
      'name_IT'            => 'Wallis e Futuna',
      'name_PT'            => 'Wallis e Futuna'
      ),
    'WS' => array(
      'iso_3166_1_alpha_3' => 'WSM',
      'iso_3166_1_numeric' => '882',
      'ccTLD'              => '.ws',
      'name_EN'            => 'Samoa',
      'name_DE'            => 'Samoa',
      'name_ES'            => 'Samoa',
      'name_FR'            => 'Samoa',
      'name_IT'            => 'Samoa',
      'name_PT'            => 'Samoa (Samoa Ocidental)'
      ),
    'YE' => array(
      'iso_3166_1_alpha_3' => 'YEM',
      'iso_3166_1_numeric' => '887',
      'ccTLD'              => '.ye',
      'name_EN'            => 'Yemen',
      'name_DE'            => 'Jemen',
      'name_ES'            => 'Yemen',
      'name_FR'            => 'Yémen',
      'name_IT'            => 'Yemen',
      'name_PT'            => 'Iémen'
      ),
    'YT' => array(
      'iso_3166_1_alpha_3' => 'MYT',
      'iso_3166_1_numeric' => '175',
      'ccTLD'              => '.yt',
      'name_EN'            => 'Mayotte',
      'name_DE'            => 'Mayotte',
      'name_ES'            => 'Mayotte',
      'name_FR'            => 'Mayotte',
      'name_IT'            => 'Mayotte',
      'name_PT'            => 'Mayotte'
      ),
    'ZA' => array(
      'iso_3166_1_alpha_3' => 'ZAF',
      'iso_3166_1_numeric' => '710',
      'ccTLD'              => '.za',
      'name_EN'            => 'South Africa',
      'name_DE'            => 'Südafrika',
      'name_ES'            => 'Sudáfrica',
      'name_FR'            => 'Afrique du Sud',
      'name_IT'            => 'Sudafrica',
      'name_PT'            => 'África do Sul'
      ),
    'ZM' => array(
      'iso_3166_1_alpha_3' => 'ZMB',
      'iso_3166_1_numeric' => '894',
      'ccTLD'              => '.zm',
      'name_EN'            => 'Zambia',
      'name_DE'            => 'Sambia',
      'name_ES'            => 'Zambia',
      'name_FR'            => 'Zambie',
      'name_IT'            => 'Zambia',
      'name_PT'            => 'Zâmbia'
      ),
    'ZW' => array(
      'iso_3166_1_alpha_3' => 'ZWE',
      'iso_3166_1_numeric' => '716',
      'ccTLD'              => '.zw',
      'name_EN'            => 'Zimbabwe',
      'name_DE'            => 'Simbabwe',
      'name_ES'            => 'Zimbabue',
      'name_FR'            => 'Zimbabwe',
      'name_IT'            => 'Zimbabwe',
      'name_PT'            => 'Zimbabwe'
      ),
// --- /DYN
      );
  } // END getCountryCodes



}
