<?php
/**
 * Codemirror2 be_style Plugin for Redaxo
 *
 * @version 1.3.1
 * @link https://github.com/marijnh/CodeMirror2
 * @author Redaxo be_style plugin: rexdev.de
 * @package redaxo 4.3.x/4.4.x/4.5.x
 */


// GET PARAMS
////////////////////////////////////////////////////////////////////////////////
$mypage     = 'rex_codemirror';
$myroot     = $REX['INCLUDE_PATH'].'/addons/be_style/plugins/'.$mypage.'/';
$subpage    = rex_request('subpage', 'string');
$func       = rex_request('func', 'string');


// PAGE HEAD
////////////////////////////////////////////////////////////////////////////////
require $REX['INCLUDE_PATH'] . '/layout/top.php';

rex_title('Backend Style <span style="color:silver;font-size:0.5em;">'.$REX['ADDON']['plugins']['be_style']['version'][$mypage].'</span>',$REX['ADDON']['be_style']['SUBPAGES']);


// SAVE SETTINGS
////////////////////////////////////////////////////////////////////////////////
if($func=='save_settings'){
  $settings   = rex_request('settings', 'array');
  foreach($settings as $k => $v){
    $settings[$k] = stripslashes($v);
  }

  $content = '$REX["rex_codemirror"]["settings"] = '.var_export($settings,true).';';
  if(rex_replace_dynamic_contents($myroot.'config.inc.php', $content)){
    $REX["rex_codemirror"]["settings"] = $settings;
    echo rex_info('Settings saved.');
  }else{
    echo rex_warning('unknown save error');
  }
}


// PAGE BODY
////////////////////////////////////////////////////////////////////////////////

// THEME SELECT
$theme_dirs = glob($myroot.'files/themes/*');
$tmp = new rex_select();
$tmp->setSize(1);
$tmp->setName('settings[theme]');
foreach(glob($myroot.'files/vendor/theme/*.css') as $theme_css){
  $theme = str_replace(array($myroot.'files/vendor/theme/','.css'),'',$theme_css);
  $tmp->addOption($theme,$theme);
}
$tmp->setSelected($REX[$mypage]['settings']['theme']);
$theme = $tmp->get();

// JQUERY INJECT SELECT
$tmp = new rex_select();
$tmp->setSize(1);
$tmp->setName('settings[foldmode]');
$tmp->addOption('tagRangeFinder (HTML)','tagRangeFinder');
$tmp->addOption('braceRangeFinder (PHP)','braceRangeFinder');
$tmp->setSelected($REX[$mypage]['settings']['foldmode']);
$foldmode = $tmp->get();


// SUBSUB NAVI
#$subsubnavi = $subsubnavi == '' ? 'Es sind keine Plugins installiert/aktiviert.' : $subsubnavi;

echo '
<!--<div class="rex-addon-output im-plugins">
  <h2 class="rex-hl2" style="font-size:1em;border-bottom:0;">./*$subsubnavi*/.</h2>
</div>-->

<div class="rex-addon-output im-plugins">
  <div class="rex-form">

    <form action="index.php?page=be_style&subpage='.$mypage.'" method="post">
      <input type="hidden" name="page" value="be_style" />
      <input type="hidden" name="subpage" value="'.$mypage.'" />
      <input type="hidden" name="func" value="save_settings" />
      <input type="hidden" name="codemirror_options" value="" />

      <fieldset class="rex-form-col-1">
        <legend style="font-size:1.2em">RexCodemirror Settings</legend>
          <div class="rex-form-wrapper">


            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-select">
                <label for="theme">Theme</label>
                '.$theme.'
              </p>
            </div><!-- /rex-form-row -->


            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-text">
                <label for="trigger_class">Trigger Class</label>
                <input id="trigger_class" class="rex-form-text" type="text" name="settings[trigger_class]" value="'.
                $REX[$mypage]['settings']['trigger_class'].
                '" />
              </p>
            </div><!-- /rex-form-row -->


            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-text">
                <label for="enter_fullscreen">Enter Fullscreen</label>
                <input id="enter_fullscreen" class="rex-form-text" type="text" name="settings[enter_fullscreen_key]" value="'.
                $REX[$mypage]['settings']['enter_fullscreen_key'].
                '" />
              </p>
            </div><!-- /rex-form-row -->


            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-text">
                <label for="leave_fullscreen">Leave Fullscreen</label>
                <input id="leave_fullscreen" class="rex-form-text" type="text" name="settings[leave_fullscreen_key]" value="'.
                $REX[$mypage]['settings']['leave_fullscreen_key'].
                '" />
              </p>
            </div><!-- /rex-form-row -->


            <div class="rex-form-row">
              <p class="rex-form-col-a rex-form-select">
                <label for="theme">Foldmode</label>
                '.$foldmode.'
              </p>
            </div><!-- /rex-form-row -->

              <div class="rex-form-row rex-form-element-v2">
                <p class="rex-form-submit">
                  <input class="rex-form-submit" type="submit" id="sendit" name="sendit" value="Einstellungen speichern" />
                </p>
              </div><!-- /rex-form-row -->

            </div><!-- /rex-form-wrapper -->
        </fieldset>
      </form>
    </div><!-- /rex-form -->
  </div><!-- /rex-addon-output -->
  ';


require $REX['INCLUDE_PATH'] . '/layout/bottom.php';
