Redaxo Addon iw_assets
======================

iw_assets kombiniert lessphp und minify: https://github.com/leafo/lessphp / https://github.com/mrclay/minify

Installation
------------

Addon herunterladen und wie alle anderen Redaxo Addons installieren. WICHTIG: das oberste Addon Verzeichnis muss "iw_assets" heissen, nach dem Download als zip von Github heisst es "iw_assets-master" - sprich es muss umbenannt werden.

Schnelleinstieg
---------------

Im Template ein iw_assets Objekt erstellen und die Pfade zu den Dateien angeben:

    $assets = new iw_assets();
    $assets->add('layout/normalize.css');
    $assets->add('layout/structure.css');
    $assets->add('layout/base.less');
    $assets->add('layout/jquery.js');
    $assets->add('layout/standard.js');
    $assets->add('layout/jquery.cycle.lite.js');

Dann an der gewünschten Stelle die kombinierten Dateien ausgeben:

    echo $assets->get_css();
    echo $assets->get_js();

Gruppen
-------

Bei Bedarf können Gruppen definiert werden, falls z.B. ein Teil der Skripte im &lt;head&gt; und ein anderer Teil vor &lt;/body&gt; ausgegeben werden soll:

    $assets->add('layout/jquery.js', 'head');
    $assets->add('layout/standard.js', 'head');
    $assets->add('layout/jquery.cycle.lite.js', 'body');

    echo $assets->get_js('head');
    ...
    echo $assets->get_js('body');

.less Dateien
-------------

.less Dateien werden über lessphp in .css Dateien umgewandelt. Die .css Datei wird im selben Verzeichnis wie die .less Datei gespeichert. Zusätzlich wird auch noch eine .cache Datei erstellt und gespeichert. Diese ist nötig um weitere über @import eingebundene .less Dateien automatisch kompilieren zu können.

Methoden
--------

    $assets->add($filepath, $groupname = 'default');

Fügt eine Datei zu einer Gruppe hinzu. Wird keine Gruppe angegeben, wird automatisch zur Gruppe 'default' hinzugefügt.

    echo $assets->get_css($groupname = 'default', $mediatype = 'all');
    echo $assets->get_js($groupname = 'default');

Gibt für die Dateien der Gruppe eine &lt;link&gt; / &lt;script&gt; Referenz aus. Die im href bzw. src Attribut angegebenen Dateien werden von minify zusammengefasst, eingedampft und gzip-komprimiert zurückgegeben.

    $assets = new iw_assets();
    $assets->debug();
    ...

Aktiviert den debug-Modus, für jede Datei wird eine einzelne &lt;link&gt; / &lt;script&gt; Referenz ausgegeben.

APC statt Dateisystem Cache
---------------------------

In der /files/addons/iw_assets/index.php tauschen:

    require $_SERVER['DOCUMENT_ROOT'].'/redaxo/include/addons/iw_assets/classes/min/lib/Minify/Cache/File.php';
    Minify::setCache(new Minify_Cache_File());

gegen

    require $_SERVER['DOCUMENT_ROOT'].'/redaxo/include/addons/iw_assets/classes/min/lib/Minify/Cache/APC.php';
    Minify::setCache(new Minify_Cache_APC());
